' ########################################################################################
' CSED Editor
' File: CSED_PROJECTS_BEENE.BAS
' Contents: CSED editor Projects
' Copyright (c) 2013 Gary Beene
' All Rights Reserved.
' Compiler: PowerBASIC for Windows 10.01+
' Headers: Windows API Headers 2.02+
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################

Sub Beene_Settings_INI(Task$)
   Local i As Long, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + $PROGNAME + ".ini"
   If Task$ = "get" Then
      'get value for string variables
      Getprivateprofilestring "Beene", "ProjectFile", "", ProjectFile, %Max_Path, INIFileName
      Getprivateprofilestring "Beene", "ProjectExt", ".bas.inc", ProjectExt, %Max_Path, INIFileName
      For i = 1 To 10
         Getprivateprofilestring "Beene", "RecentProject" + Format$(i,"00"), "", ProjectRecentArray(i), %Max_Path, INIFileName
      Next i
      'get value for numeric variables
'      Getprivateprofilestring "Beene", "FontSize", "10", temp, %Max_Path, INIFileName:  FontSize = Val(temp)
   End If

   If Task$ = "save" Then
      'save string variables
      WritePrivateProfileString "Beene", "ProjectFile", ProjectFile, INIFileName
      WritePrivateProfileString "Beene", "ProjectExt", ProjectExt, INIFileName
      For i = 1 To 10
         WritePrivateProfileString "Beene", "RecentProject" + Format$(i,"00"), ProjectRecentArray(i), INIFileName
      Next i
      'save numeric variables
'      WritePrivateProfileString "Beene", "FontSize", Str$(FontSize), INIFileName
   End If
End Sub

Sub Beene_ProjectData
   Local temp$, i As Long
   If Len(ProjectFile) Then
      temp$ = "Project File:" + $CrLf + ProjectFile + $CrLf + $CrLf + "File List: "
      If UBound(ProjectFileArray) = 0 Then
         temp$ += $CrLf + "<project has no files>"
      Else
         For i = 1 To UBound(ProjectFileArray)
            temp$ += $CrLf + ProjectFileArray(i)
         Next i
      End If
   Else
      temp$ = "<no project loaded>"
   End If
   MsgBox temp$, %MB_Ok + %MB_IconInformation, "Project Summary"
End Sub

Function Beene_ProjectFileAnalysis(NewProjectFile$) As Long
   Local temp$,D$
   D$ = ":::"
   If IsFalse(IsFile(NewProjectFile$)) Then Function = 2 : Exit Function
   Open NewProjectFile$ For Input As #1
   While IsFalse Eof(1)
      Line Input #1, temp$
      If IsFalse(IsFile(Parse$(temp$,D$,1))) Then Function = 1 : Exit Loop
   Wend
   Close #1
End Function

Sub Beene_LocateProcedure(GoBackFlag As Long)
   Local i,j,iResult,nTAB,iPos,iLen,nChars,tLen As Long, hMDI,hSci As Dword
   Local vPath As Variant, fName$, tmp$, temp$,sciText$
   Local pTabFilePaths   As ILinkListCollection    ' // File paths linked list
   Static PreviousTAB, PreviousCaret As Long

   If GoBackFlag = %True Then
      TabCtrl_SetCurSel(pSed.hTabMdi, PreviousTAB)                 'select the TAB
      pTabFilePaths = pSed.TabFilePaths
      vPath = pTabFilePaths.Item(PreviousTab + 1)
      CSED_TabMdiActivateWindow(Variant$$(vPath))
      SCI_GoToPos(pSed.hEdit,PreviousCaret)
      Exit Sub
   End If

   'save current location
   PreviousTAB = TabCtrl_GetCurSel(pSed.hTabMDI)
   PreviousCaret = SCI_GetCurrentPos(pSed.hEdit)

   'get the highlighted text
   i = SendMessage( pSed.hEdit, %SCI_GetSelText, 0, 0)       'get required buffer length
   temp$ = String$(i," ") + Chr$(0)                          'size the buffer
   SendMessage pSed.hEdit, %SCI_GetSelText, 0, StrPtr(temp$) 'get the text

   'strings to look for (put in target() ------------------------
   tmp$ = LTrim$(LCase$(temp$))

   If Trim$(tmp$,Chr$(0)) = "" Then Beep : Exit Sub

   Dim target(7) As StringZ * 65
   target(0) = "sub " + tmp$               : target(1) = "function " + tmp$
   target(2) = "static sub " + tmp$        : target(3) = "static function " + tmp$
   target(4) = "callback function " + tmp$ : target(5) = "fastproc function " + tmp$
   target(6) = "method " + tmp$            : target(7) = "macro " + tmp$

   'enumerate Edit windows----------------------------------------
   AfxDisableWindowRedraw pSed.hwndClient                   'disable redraw
   hMDI = GetWindow(pSed.hwndClient, %GW_Child)
   While hMDI
      hSci = GetDlgItem(hMDI, %IDC_Edit)
      '---highlight search string, if found, in newly activated TAB edit control ----------
      nChars = SendMessage(hSci, %SCI_GetLength, 0, 0)
      sciText$ = String$(nChars,Chr$(0))
      SendMessage hSci, %SCI_GetText, nChars, StrPtr(sciText$)
      For j = 0 To UBound(target)
'         RegExpr "[^ ']\b" + target(j) In sciText$ To iPos
         RegExpr "^[ \t]*\b" + target(j) In sciText$ To iPos, iLen
         If iPos Then
            vPath = AfxGetWindowText(hMdi)                        'get path from the collection
            nTab = CSED_GetTabNumberFromPath(Variant$$(vPath))    'get TAB number from Path
            TabCtrl_SetCurSel(pSed.hTabMdi, nTab)                 'select the TAB
            MDIActivate(pSed.hwndClient, hMdi)                    'activate this MDI child window
'            SendMessage pSed.hEdit, %SCI_SetSel, iPos, iPos+Len(target(j))
            SendMessage pSed.hEdit, %SCI_SetSel, iPos+iLen-Len(target(j))-1, iPos+iLen-1
            AfxEnableWindowRedraw pSed.hwndClient                 'enable redraw
            RedrawWindow pSed.hEdit, ByVal %NULL, %NULL, %RDW_ERASE Or %RDW_FRAME Or %RDW_INVALIDATE
            Exit Sub
         End If
      Next j
      '-----------------------------------------------------------------
      hMDI = GetWindow(hMDI, %GW_HWNDNEXT)
   Wend
   AfxEnableWindowRedraw pSed.hwndClient        'enable redraw
   fName$ = Beene_SearchProjectFiles(target(), iPos, iLen, j)   'returns file containing target or returns ""
   If IsFile(fName$) Then
      CSED_OpenFile(fName$)
'      SendMessage pSed.hEdit, %SCI_SetSel, iPos, iPos+tLen
      SendMessage pSed.hEdit, %SCI_SetSel, iPos+iLen-Len(target(j))-1, iPos+iLen-1
      If Len(ProjectFile) Then
         ProjectDirty = %True
         Beene_RefreshProjectFileArray   'update ProjectFileArray()
      End If
   Else
      MsgBox "Procedure NOT found:" + $CrLf + $CrLf + tmp$, %MB_Ok + %MB_IconExclamation, "Search for Procedure"
   End If
End Sub

Function Beene_SearchProjectFiles(target() As StringZ * 65,iPos As Long, tLen As Long, jTarget As Long) As String
   Local i As Long, temp$, tmp$, xtn$, ProjectPath As String
   ProjectPath = PathName$(Path,ProjectFile)
   'build ProjectFileArray
   Beene_RefreshProjectFileArray
   'for each *.bas file in folder of ProjectFile, search any non-Project file
   temp$ = Dir$(ProjectPath + "*.*")
   While Len(temp$)
      xtn = LCase$(PathName$(Extn,temp$))
      If InStr(ProjectExt,xtn) Then
         temp$ = ProjectPath + temp$
         'check file for any of the possible targets
         Open temp$ For Binary As #1 : Get$ #1, Lof(1), tmp$ : Close #1
         For i = 0 To UBound(target)
'            RegExpr "[^ ']\b" + target(i) In tmp$ To iPos
            RegExpr "^[ \t]*\b" + target(i) In tmp$ To iPos, tLen
            If iPos Then   'match found
               jTarget = i
               Function = temp$
               Exit, Exit
            End If
         Next
      End If
      temp$ = Dir$(Next)
   Wend
End Function

Sub Beene_SaveAll
   'Save All
   If pSed.hEdit Then UpdateWindow(pSed.hEdit)
   CSED_SaveLoadedFiles pSed.hwndMain
   CSED_ChangeMenuItemsState
End Sub

Sub Beene_CloseAll
   'asks user to save any unsaved files
   Local hwndClient As Dword
   ' // Close all the MDI child windows
   hwndClient = CWindow_GetMDIClientHandle(pSed.hwndMain)
   If hwndClient Then
      EnumChildWindows hwndClient, CodePtr(CSED_CloseEnumProc), 0
   End If
   CSED_ChangeToolbarButtonsState
   CSED_ChangeMenuItemsState
   ' // Enable open just in case it has been disabled
   EnableMenuItem pSed.hMenuFile, %IDM_OPEN, %MF_Enabled
   Toolbar_EnableButton(pSed.hToolbar, %IDM_OPEN)
   ' // If there are not child windows open, clear the status bar
   If GetWindow(hwndClient, %GW_CHILD) = 0 Then CSED_ClearStatusBar
End Sub

Sub Beene_RefreshProjectFileArray
   Local vPath As Variant, hMDI As Dword, iCount As Long
   ReDim ProjectFileArray(0)                                'remove all entries 0 position not used
   hMDI = GetWindow(pSed.hwndClient, %GW_Child)
   While hMDI
      vPath = AfxGetWindowText(hMdi)                        'get path from the collection
      Incr iCount                                           'position 0 not used
      ReDim Preserve ProjectFileArray(iCount)               'make room for next file name
      ProjectFileArray(iCount) = Variant$$(vPath)           'add file name to array
      hMDI = GetWindow(hMDI, %GW_HWNDNEXT)                  'get next TAB
   Wend
End Sub

Sub Beene_RefreshProjectRecentArrayAndMenu
   Local i,iResult,iCount As Long
   'remove old menu entries
   For i = 20 To 10 Step -1 : Menu Delete pSed.hMenuProject, i : Next i   'remove Separator + 10 IDM_RecentX menu items
   'if ProjectFile exists and is already in array then delete the one already there
   'then put the name of the current ProjectFile at the top of the array (if it exists)
   If Len(ProjectFile) Then
      Array Scan ProjectRecentArray(1), Collate UCase, = ProjectFile, To iResult
      If iResult Then Array Delete ProjectRecentArray(iResult)
      Array Insert ProjectRecentArray(1), ProjectFile
   End If
   'add new
   If Len(Join$(ProjectRecentArray(),"")) Then AppendMenu pSed.hMenuProject, %MF_SEPARATOR, 0, ""
   For i = 1 To 10
      If IsFile(ProjectRecentArray(i)) Then
         AppendMenu pSed.hMenuProject, %MF_Enabled, %IDM_RECENTP01+iCount, ProjectRecentArray(i)    'BEENE
         Incr iCount
      End If
   Next i
End Sub

Sub Beene_NewProject
   If Len(ProjectFile) And Beene_AnyFileIsDirty Then ProjectDirty = %True
   If ProjectDirty Then
      Select Case MsgBox("Save Existing Project/File changes?", %MB_YesNoCancel, "New Project")
         Case %IdYes
            Beene_SaveProjectFile
            Beene_SaveAll   'closes all open file without asking user to save changes
            Beene_CloseAll  'asks user to save any unsaved files
            ProjectFile = "untitled_project.sed"
            ProjectDirty = %False
            AfxSetWindowText pSed.hwndMain, $CSEDCAPTION + IIf$(Len(ProjectFile)," - ","") + PathName$(Namex,ProjectFile)
            Beene_RefreshProjectFileArray   'update ProjectFileArray()
            Beene_RefreshProjectRecentArrayAndMenu   'update ProjectRecentArray() and corresponding menus
         Case %IdNo
            Beene_CloseAll   'asks user to save any unsaved files
            ProjectFile = "untitled_project.sed"
            ProjectDirty = %False
            AfxSetWindowText pSed.hwndMain, $CSEDCAPTION + IIf$(Len(ProjectFile)," - ","") + PathName$(Namex,ProjectFile)
            Beene_RefreshProjectFileArray   'update ProjectFileArray()
            Beene_RefreshProjectRecentArrayAndMenu   'update ProjectRecentArray() and corresponding menus
         Case %IdCancel
            'no action, cancel New Project action
      End Select
   Else
      Beene_CloseAll   'asks user to save any unsaved files
      ProjectFile = "untitled_project.sed"
      ProjectDirty = %False
      AfxSetWindowText pSed.hwndMain, $CSEDCAPTION + IIf$(Len(ProjectFile)," - ","") + PathName$(Namex,ProjectFile)
      Beene_RefreshProjectFileArray   'update ProjectFileArray()
      Beene_RefreshProjectRecentArrayAndMenu   'update ProjectRecentArray() and corresponding menus
   End If
End Sub

Function Beene_OpenProjectFileDialog () As Long
   Local i,nCount                                    As Long
   Local dwStyle                                     As Dword
   Local strInitialDir, strFileSpec, strDefExtension As WString
   Local strFilter, strPath, strFile                 As WString

   strInitialDir = CurDir$
   strFileSpec = "*.sed"
   strDefExtension = "sed"
   strFilter  = "CSED Project Files (*.sed)|.sed"
   dwStyle = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly

   If AfxOpenFileDialog(pSed.hwndMain, "Open Project", strFileSpec, strInitialDir, strFilter, strDefExtension, dwStyle) Then
      strFileSpec = RTrim$(strFileSpec, Chr$(0))
      If Len(strFileSpec) Then Beene_OpenProjectFile(LCase$(strFileSpec))
   End If
End Function

Sub Beene_OpenProjectFile(NewProjectName$)
   Local temp$, Flag As Long, D$, ActiveFile$
   D$ = ":::"
   If Len(NewProjectName$) Then
      Select Case Beene_ProjectFileAnalysis(NewProjectName$)
         Case 2 'bad file name
            MsgBox "Cannot locate Project file!", %MB_Ok + %MB_IconExclamation,"Open Project"
            Exit Sub
         Case 1 'one or more bad file names
            If MsgBox("One or more files listed in the Project cannot be found. Continue?", %MB_OkCancel + %MB_IconQuestion,"Open Project") = %IdCancel Then Exit Sub
         Case Else
            'no action
      End Select
   End If

   If Len(ProjectFile) And Beene_AnyFileIsDirty Then ProjectDirty = %True
   If ProjectDirty Then
      Select Case MsgBox("Save Existing Project/File changes?", %MB_YesNoCancel, "Open Project")
         Case %IdYes
            Beene_SaveProjectFile
            Beene_SaveAll   'closes all open file without asking user to save changes
            Beene_CloseAll   'asks user to save any unsaved files
            ProjectFile = NewProjectName$
            ProjectDirty = %False
            AfxSetWindowText pSed.hwndMain, $CSEDCAPTION + IIf$(Len(ProjectFile)," - ","") + PathName$(Namex,ProjectFile)
            Flag = 1
         Case %IdNo
            Beene_CloseAll   'asks user to save any unsaved files
            ProjectFile = NewProjectName$
            ProjectDirty = %False
            AfxSetWindowText pSed.hwndMain, $CSEDCAPTION + IIf$(Len(ProjectFile)," - ","") + PathName$(Namex,ProjectFile)
            Flag = 1
         Case %IdCancel
            'no action, cancel Close action
      End Select
   Else
      Beene_SaveAll   'closes all open file without asking user to save changes
      Beene_CloseAll   'asks user to save any unsaved files
      ProjectFile = NewProjectName$
      ProjectDirty = %False
      AfxSetWindowText pSed.hwndMain, $CSEDCAPTION + IIf$(Len(ProjectFile)," - ","") + PathName$(Namex,ProjectFile)
      Flag = 1
   End If

   If Flag Then   'load files found in ProjectFile
      Open ProjectFile For Input As #1
      While IsFalse Eof(1)
         Line Input #1, temp$
         If IsFile(Parse$(temp$,D$,1)) Then
            CSED_OpenFile(Parse$(temp$,D$,1))                                 '1=file name
            If Val(Parse$(temp$,D$,2)) Then ActiveFile$ = Parse$(temp$,D$,1)  '2=active (0 or 1)
            SCI_GoToPos(pSed.hEdit,Val(Parse$(temp$,D$,3)))                   '3=caret pos
         End If
      Wend
      Close #1
      Beene_RefreshProjectFileArray   'update ProjectFileArray()
      Beene_RefreshProjectRecentArrayAndMenu  'update ProjectRecentArray() and corresponding menus
      If Len(ActiveFile$) Then CSED_TabMdiActivateWindow ActiveFile$
   End If
End Sub

Sub Beene_CloseProjectFile
   If Beene_AnyFileIsDirty Then ProjectDirty = %True
   If ProjectDirty Then
      Select Case MsgBox("Save Project/File changes?", %MB_YesNoCancel, "Close Project")
         Case %IdYes
            Beene_SaveProjectFile
            Beene_SaveAll   'closes all open file without asking user to save changes
            Beene_CloseAll   'asks user to save any unsaved files
            ProjectFile = ""
            ProjectDirty = %False
            Beene_RefreshProjectFileArray   'update ProjectFileArray()
            Beene_RefreshProjectRecentArrayAndMenu   'update ProjectRecentArray() and corresponding menus
            AfxSetWindowText pSed.hwndMain, $CSEDCAPTION
         Case %IdNo
            Beene_CloseAll   'asks user to save any unsaved files
            ProjectFile = ""
            ProjectDirty = %False
            Beene_RefreshProjectFileArray   'update ProjectFileArray()
            Beene_RefreshProjectRecentArrayAndMenu   'update ProjectRecentArray() and corresponding menus
            AfxSetWindowText pSed.hwndMain, $CSEDCAPTION
         Case %IdCancel
            'no action, cancel Close action
      End Select
   Else
      Beene_SaveAll   'closes all open file without asking user to save changes
      Beene_CloseAll   'asks user to save any unsaved files
      ProjectFile = ""
      ProjectDirty = %False
      Beene_RefreshProjectFileArray   'update ProjectFileArray()
      Beene_RefreshProjectRecentArrayAndMenu   'update ProjectRecentArray() and corresponding menus
      AfxSetWindowText pSed.hwndMain, $CSEDCAPTION
   End If
End Sub

Function Beene_SaveAsProjectFileDialog () As Long
   Local bstrFile, bstrTitle, bstrInitialDir, bstrFilter, bstrDefExt As WString, ofn As OPENFILENAMEW
   'values to use in dialog
   bstrTitle = "Save Project As"
   bstrFile = IIf$(IsFile(ProjectFile),ProjectFile,"untitled.sed") + $Nul
   bstrFile += Space$(%Max_Path-Len(bStrFile))
   bstrInitialDir = IIf$(IsFile(ProjectFile),PathName$(Path,ProjectFile),Exe.Path$)
   bstrFilter += "CSED Project Files (*.sed)" + $Nul + "*.sed" + $Nul + $Nul
   bstrDefExt = "sed"

   'set OFN structure
   If AfxGetWindowsVersion < 5 Then ofn.lStructSize   = 76  Else ofn.lStructSize   = SizeOf(ofn)
   ofn.hwndOwner       = pSed.hwndMain

   ofn.lpstrTitle      = StrPtr(bstrTitle)
   ofn.lpstrFile       = StrPtr(bstrFile)
   ofn.lpstrInitialDir = StrPtr(bstrInitialDir)
   ofn.lpstrFilter     = StrPtr(bstrFilter)
   ofn.lpstrDefExt     = StrPtr(bstrDefExt)

   ofn.nMaxFile        = Len(bstrFile)
   ofn.Flags           = %OFN_Explorer Or %OFN_PathMustExist Or %OFN_OverWritePrompt Or %OFN_HideReadOnly

   Function = GetSaveFilenameW(ofn)
   bstrFile = Trim$(bstrFile,$Nul)
   If Len(bstrFile) Then
       ProjectFile = bstrFile
       Beene_SaveAll   'closes all open file without asking user to save changes
       Beene_SaveProjectFile
       Beene_RefreshProjectFileArray   'update ProjectFileArray()
       Beene_RefreshProjectRecentArrayAndMenu  'update ProjectRecentArray() and corresponding menus
       AfxSetWindowText pSed.hwndMain, $CSEDCAPTION + IIf$(Len(ProjectFile)," - ","") + PathName$(Namex,ProjectFile)
   End If
End Function

Sub Beene_SaveProjectFile_old
   Local vPath As Variant, hMDI,hSci As Dword, nSelTab,nTab,CaretPos As Long
   Local D$
   D$ = ":::"
   'Save file list to Project File---------------------------
   nSelTab = TabCtrl_GetCurSel(pSed.hTabMDI)
   Open ProjectFile For Output As #1
   hMDI = GetWindow(pSed.hwndClient, %GW_Child)
   While hMDI
      vPath = AfxGetWindowText(hMdi)         'get path from the collection
      nTab = CSED_GetTabNumberFromPath(Variant$$(vPath))    'get TAB number from Path
      hSci = GetDlgItem(hMDI, %IDC_Edit)
      caretPos = SCI_GetCurrentPos(hSci)
      Print #1, LCase$(Variant$$(vPath)) + D$ + IIf$(nSelTab=nTab,"1","0") + D$ + Str$(CaretPos)   'name - selected y/n - caret pos
      hMDI = GetWindow(hMDI, %GW_HWNDNEXT)
   Wend
   Close #1
   ProjectDirty = %False
End Sub

Sub Beene_SaveProjectFile
   Local vPath As Variant, hMDI,hSci As Dword, nSelTab,nTab,CaretPos As Long
   Local D$
   D$ = ":::"
   'Save file list to Project File---------------------------
   nSelTab = TabCtrl_GetCurSel(pSed.hTabMDI)+1
   Open ProjectFile For Output As #1
   For nTab = 1 To psed.TabFilePaths.Count
      hMDI = hMDIofTAB(nTab-1)
      vPath = AfxGetWindowText(hMdi)    'alternate - vPath = pTabFilePaths.Item(nTab+1)
      hSci = GetDlgItem(hMDI, %IDC_Edit)
      caretPos = SCI_GetCurrentPos(hSci)
      Print #1, LCase$(Variant$$(vPath)) + D$ + IIf$(nSelTab=nTab,"1","0") + D$ + Str$(CaretPos)   'name - selected y/n - caret pos
   Next nTab
   Close #1
   ProjectDirty = %False
End Sub

Function hMDIofTAB(TargetTAB As Long) As Dword
   Local vPath As Variant, hMDI As Dword, nTAB As Long
   hMDI = GetWindow(pSed.hwndClient, %GW_Child)
   While hMDI
      vPath = AfxGetWindowText(hMdi)                        'get path from the collection
      nTab = CSED_GetTabNumberFromPath(Variant$$(vPath))    'get TAB number from Path
      If nTab = TargetTAB Then Function = hMDI : Exit Function
      hMDI = GetWindow(hMDI, %GW_HWNDNEXT)
   Wend
End Function

Function Beene_Test() As Long
   ? "No Test Function Defined"
'   ? Str$(TabCtrl_GetItemCount(pSed.hTabMdi))
'   Local vPath As Variant, hMDI As Dword
'   hMDI = GetWindow(pSed.hwndClient, %GW_Child)
'   While hMDI
'      vPath = AfxGetWindowText(hMdi)         'get path from the collection
'      ? Variant$$(vpath)
'      hMDI = GetWindow(hMDI, %GW_HWNDNEXT)
'   Wend
'   ProjectDirty = %False
End Function

Function Beene_DirtyFileList() As String
   'returns list of dirty file.  separated by $crlf
   Local hMDI As Dword, temp$
   hMDI = GetWindow(pSed.hwndClient, %GW_Child)
   While hMDI
      If SCI_GetModify(GetDlgItem(hMDI,%IDC_Edit)) Then
         temp$ = Variant$$(AfxGetWindowText(hMdi)) + $CrLf + temp$
      End If
      hMDI = GetWindow(hMDI, %GW_HWNDNEXT)
   Wend
   Function = Trim$(temp$,$CrLf)
End Function

Function Beene_AnyFileIsDirty() As Long
   'if any file is dirty, then function returns 1
   Local hMDI As Dword
   hMDI = GetWindow(pSed.hwndClient, %GW_Child)
   While hMDI
      If SCI_GetModify(GetDlgItem(hMDI,%IDC_Edit)) Then Function = %True : Exit Function
      hMDI = GetWindow(hMDI, %GW_HWNDNEXT)
   Wend
End Function

Sub Beene_ChangeMenuItemsState
   If Len(ProjectFile) = 0 Then
      EnableMenuItem(pSed.hMenuProject, %IDM_CLOSEP, %MF_Grayed)
      EnableMenuItem(pSed.hMenuProject, %IDM_SAVEP, %MF_Grayed)
      EnableMenuItem(pSed.hMenuProject, %IDM_GOTOFOLDERP, %MF_Grayed)
      EnableMenuItem(pSed.hMenuProject, %IDM_PROJECTDATA, %MF_Grayed)
   Else
      EnableMenuItem(pSed.hMenuProject, %IDM_CLOSEP, %MF_Enabled)
      EnableMenuItem(pSed.hMenuProject, %IDM_SAVEP, %MF_Enabled)
      EnableMenuItem(pSed.hMenuProject, %IDM_GOTOFOLDERP, %MF_Enabled)
      EnableMenuItem(pSed.hMenuProject, %IDM_PROJECTDATA, %MF_Enabled)
   End If
End Sub
