'+* ########################################################################################
' CSED Editor
' File: CSED.BAS

type test


if asdf

end if

end type
' Contents: CSED editor main source file
' Copyright (c) 2011 Jos Roca
' All Rights Reserved.
' Compiler: PowerBASIC for Windows 10.01+
' Headers: Windows API Headers 2.02+
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
'-* ########################################################################################

#Compile Exe "CSED_new.exe"
#Dim All
%UNICODE = 1
#utility

' // Globals
Global pSed As ISED   ' // Reference to the ISED interface

' // Constants
$PROGNAME      = "CSED"
$CSEDVERSION   = "1.03"
$CSEDCAPTION   = "CSED 1.03"
$CSEDCOPYRIGHT = " 2011 by Jos Roca"
$MAILADDRESS   = "JRoca@com.it-berater.org"
$CODETIPSDB    = "CSED_CODETIPS.TRM"    ' // Codetips database name
$BACKUPSDB     = "CSED_BACKUPMGR.TRM"   ' // Backups database name

' // Icon identifiers
%IDI_PROGRAMICO  = 100
%IDI_EDITICO     = 101
%IDI_TABCLOSEICO = 102

' // Resource file
#Resource Res, ".\Resources\CSED.RES"  ' // Editor resource file

' // Include files
%USEMDI = 1                            ' // Use MDI
%USEWEBBROWSER = 1                     ' // Use WebBrowser control

' ========================================================================================
' CSED tools record structure
' ========================================================================================
Type CSED_TOOLSTYPE
   strName   As String * 64
   strPath   As String * 256
   strParams As String * 1023
   strMenu   As String * 1
End Type
' ========================================================================================

' // Include files for external files
#Include Once "CWindow.inc"            ' // CWindow class
#Include Once "AfxWin.inc"             ' // Application Framework Extensions Library
#Include Once "AfxDlg.inc"             ' // Common dialogs
#Include Once "CommCtrl.inc"           ' // Common controls
#Include Once "ShlObj.inc"             ' // Windows shell
#Include Once "HtmlHelp.inc"           ' // HTML Help
#Include Once "vshelp.inc"             ' // DExplorer interfaces
#Include Once "Scintilla.inc"          ' // Scintilla edit control
#Include Once "TRM.inc"                ' // Tsunami Record Manager
#Include Once "AfxShell.inc"           ' // Shell wrapper functions

' // Include files for internal files
#Include Once "CSED_ENUMS.inc"         ' // Enumerations
#Include Once "CSED_CLASSES.inc"       ' // CSED and CFindReplace classes
#Include Once "CSED_TOOLBARS.inc"      ' // Toolbars
#Include Once "CSED_STATUSBAR.inc"     ' // Statusbar
#Include Once "CSED_TABCTRL.inc"       ' // Tab control
#Include Once "CSED_FILE.inc"          ' // File procedures
#Include Once "CSED_COMPILE.inc"       ' // Compilation related procedures
#Include Once "CSED_GOTOPROC.inc"      ' // Go to beginning/end procedure
#Include Once "CSED_SCI.inc"           ' // Scintilla related functions
#Include Once "CSED_HELP.inc"          ' // Context menu help
#Include Once "CSED_MENU.inc"          ' // Menu

' // Dialogs
#Include Once "CSED_GOTOLINE.inc"      ' // Go to line dialog
#Include Once "CSED_PRINT.inc"         ' // Printing
#Include Once "CSED_PBTPL.inc"         ' // Templates
#Include Once "CSED_RECENTFILES.inc"   ' // Recent files
#Include Once "CSED_EDOPT.inc"         ' // Editor options dialog
#Include Once "CSED_FOLDOPT.inc"       ' // Fold options dialog
#Include Once "CSED_CMPOPT.INC"        ' // Compiler options dialog
#Include Once "CSED_COLOROPT.inc"      ' // Colors and fonts dialog

' // Include files for wrapper functions
#Include Once "SciCtrl.inc"            ' // Scintilla edit control wrappers
#Include Once "ToolbarCtrl.inc"        ' // Toolbar control wrapper functions
#Include Once "StatusbarCtrl.inc"      ' // Status bar wrapper functions
#Include Once "TabCtrl.inc"            ' // Tab control wrapper functions
#Include Once "ComboBoxCtrl.inc"       ' // Combo box wrapper functions
#Include Once "ListBoxCtrl.inc"        ' // List box wrapper functions
#Include Once "EditCtrl.inc"           ' // Edit control wrapper functions
#Include Once "TreeViewCtrl.inc"       ' // TreeView control wrapper functions
#Include Once "CAfxImageList.inc"      ' // Image List class

' ########################################################################################
' Main
' ########################################################################################
Function WinMain (ByVal hInstance As Dword, ByVal hPrevInstance As Dword, ByVal lpszCmdLine As WStringZ Ptr, ByVal nCmdShow As Long) As Long

   ' // Create an instance of the CSED class
   pSed = Class "CSED"
   If IsNothing(pSed) Then Exit Function

'   IF ISFALSE pSed.AllowMultipleInstances THEN
'      ' // Mutex to avoid multiple instances running
'      LOCAL hWindow AS DWORD
'      LOCAL hMutex AS DWORD
'#IF %DEF(%UNICODE)
'      LOCAL szMutex AS WSTRINGZ * 260
'#ELSE
'      LOCAL szMutex AS ASCIIZ * 260
'#ENDIF
'      szMutex = "CSED_MUTEX"
'      hMutex  = CreateMutex(BYVAL %NULL, %FALSE, szMutex)
'      IF ISTRUE hMutex THEN
'         IF GetLastError = %ERROR_ALREADY_EXISTS THEN
'            CloseHandle hMutex
'            ' // We can't use FindWindow because the caption of a MDI main window
'            ' // may include the path of the MDI active child windows, and we
'            ' // can't use the class name because all the CWindow main windows
'            ' // share the same class name.
'            EnumWindows(CODEPTR(CSED_EnumWindowsProc), VARPTR(hWindow))
'            IF hWindow THEN
'               SetForegroundWindow hWindow
'               CSED_ProcessCommandLine(hWindow)
'               FUNCTION = -1
'               EXIT FUNCTION
'            END IF
'         END IF
'      END IF
'   END IF

   If IsFalse pSed.AllowMultipleInstances Then
      ' // We can't use FindWindow because the caption of a MDI main window
      ' // may include the path of the MDI active child windows, and we
      ' // can't use the class name because all the CWindow main windows
      ' // share the same class name.
      Local hWindow As Dword
      EnumWindows(CodePtr(CSED_EnumWindowsProc), VarPtr(hWindow))
      If hWindow Then
         SetForegroundWindow hWindow
         CSED_ProcessCommandLine(hWindow)
         Function = -1
         Exit Function
      End If
   End If

   ' // Load Scintilla
   Local hSciLib As Dword
   hSciLib = LoadLibrary(Exe.Path$ & "SciLexer.dll")
   If hSciLib = %NULL Then Exit Function

   ' // Create an instance of the class
   Local pWindow As IWindow
   pWindow = Class "CWindow"
   If IsNothing(pWindow) Then Exit Function

   ' // Create the main window
   Local hwndMain As Dword
   Local rc As RECT
      ' Retrieve the size of the working area
   SystemParametersInfo %SPI_GETWORKAREA, 0, rc, 0
   ' // Create the window
   hwndMain = pWindow.CreateWindow(%NULL, $CSEDCAPTION, _
              0, 0, rc.Right - rc.Left, rc.Bottom - rc.Top, -1, -1, CodePtr(CSED_WindowProc), %TRUE)
   pSed.hwndMain = hwndMain
   ' // Change the class style to avoid the flicker caused by redrawing
   pWindow.ClassStyle = %CS_DBLCLKS
   ' // Center the window
   pWindow.CenterWindow hwndMain
   ' // Set the icons
   pWindow.BigIcon = LoadIcon(hInstance, ByVal %IDI_PROGRAMICO)
   pWindow.SmallIcon = LoadIcon(hInstance, ByVal %IDI_PROGRAMICO)

   ' // Create the toolbars
   CSED_CreateToolBar(pWindow)
   CSED_CreateBottomToolBar(pWindow)

   ' // Create the status bar
   CSED_CreateStatusBar(pWindow)
   CSED_ClearStatusBar

   ' // Create the menu
   CSED_CreateMenu(pWindow)
   ' // Get the recent files list
   CSED_RecentFilesMenu

   ' // Create the tab control for the MDI windows
   pSed.hTabMdi = CSED_CreateTabMdiCtrl(pWindow)

   ' // Create the MDI client window
   Local hWindowMenu As Dword
   hWindowMenu = GetSubMenu(pSed.hMenu, 5)
   Local hwndClient As Dword
   hwndClient = pWindow.CreateMDIWindow(101, 0, 0, 0, 0, -1, -1, hWindowMenu, CodePtr(CSED_MDIWindowProc))
   pSed.hwndClient = hwndClient

   ' // Initialize PB keywords
   CSED_LoadPBKeywords(hwndMain)

   ' // Create the accelerator table
   Local hAccel As Dword
   hAccel = CSED_CreateAcceleratorTable(pWindow)

   ' // Disable unusable toolbar buttons and menu items
   CSED_ChangeToolbarButtonsState
   CSED_ChangeMenuItemsState
   CSED_CheckMenuOptions(pSed.hMenu)

   ' // Enable drag and drop files
   DragAcceptFiles hwndMain, %TRUE

   ' // Read saved window's state and placement
   If pSed.WindowPlacement Then pSed.SetWindowPlacement(hwndMain)
   ' // Maximized state
   If IsTrue pSed.MaximizeMainWindow Then ShowWindow hwndMain, %SW_Maximize

   ' // Show the main window
   ShowWindow hwndMain, nCmdShow
   UpdateWindow hwndMain

   ' // Load previous file set
   If pSed.ReloadFilesAtStartup And Len(Command$) = 0 Then
      psed.LoadFileSet
   End If

   ' // Start in last used folder
   If pSed.StartInLastFolder And Len(pSed.LastFolder) Then ChDir pSed.LastFolder

   ' // If the command line isn't empty post a message to process it later
   If Len(Command$) Then PostMessage hwndMain, %WM_User + 1000, 0, 0

   If pSed.hEdit Then SetFocus pSed.hEdit

   ' // Processes window messages
   Local uMsg As tagMsg
   While GetMessage(uMsg, %NULL, 0, 0)
#If %USEOLECON = 1
   ' Forwards the message to the OCX
   If OC_ForwardMessage(GetFocus, uMsg) = 0 Then
#EndIf
#If %USEMDI = 1
         ' // Processes accelerator keystrokes for window menu command
         ' // of the multiple document interface (MDI) child windows
         If hwndClient = 0 Or TranslateMDISysAccel(hwndClient, uMsg) = 0 Then
#EndIf
            ' // Processes accelerator keys for menu commands
            If pWindow.hAccel = 0 Or TranslateAccelerator(hwndMain, hAccel, uMsg) = 0 Then
               ' // Needed to process Find and Find/Replace dialog messages
               If pSed.FindReplaceObj.hFind = 0 Or IsFalse IsDialogMessage(pSed.FindReplaceObj.hFind, uMsg) Then
                  ' // Determines whether a message is intended for the specified
                  ' // dialog box and, if it is, processes the message.
                  If IsDialogMessage(hwndMain, uMsg) = 0 Then
                     ' // Translates virtual-key messages into character messages.
                     TranslateMessage uMsg
                     ' // Dispatches a message to a window procedure.
                     DispatchMessage uMsg
                  End If
               End If
            End If
#If %USEMDI = 1
         End If
#EndIf
#If %USEOLECON = 1
      End If
#EndIf
   Wend
   Function = uMsg.wParam

   ' // Unload Scintilla
   If hSciLib Then FreeLibrary(hSciLib)

   pSed = Nothing

End Function
' ########################################################################################

' ========================================================================================
' Callback function to enumerate the top-level windows
' ========================================================================================
Function CSED_EnumWindowsProc (ByVal hwnd As Dword, ByVal lParam As Dword Ptr) As Long
   If AfxGetWindowClassName(hwnd) = "PBWindowClass:0" And _
      Left$(AfxGetWindowText(hwnd), Len($CSEDCAPTION)) = $CSEDCAPTION Then
      If lParam <> %NULL Then @lParam = hwnd
      Function = %FALSE
   Else
      Function = %TRUE
   End If
End Function
' ========================================================================================

' ========================================================================================
' Gets the command line and processes it
' ========================================================================================
Sub CSED_ProcessCommandLine (ByVal hwnd As Dword)

   Local strFileName   As String           ' // File name
   Local strLineNumber As String           ' // Line number
   Local DataToSend    As COPYDATASTRUCT   ' // Data to send structure

   If IsFalse hwnd Then Exit Sub

   If IsIconic(hwnd) <> 0 Or IsZoomed(hwnd) <> 0 Then ShowWindow hwnd, %SW_Restore
   SetForegroundWindow hwnd

   If Trim$(Command$) = "" Then Exit Sub

   strLineNumber = Right$(Command$, Len(Command$) - InStr(-1, Command$, " "))
   If Len(Trim$(strLineNumber, Any "0123456789")) Then
      strFileName = Trim$(Command$, Any $Dq + $Spc)
   Else
      strFileName = Trim$(Left$(Command$, Len(Command$) - Len(strLineNumber)), Any $Dq + $Spc)
   End If

   If Trim$(strFilename) = "" Then Exit Sub

'   IF strFileName <> "" AND PATHNAME$(PATH, strFileName) = "" THEN
'      CSED_MsgBox hwnd, "Missing path in file " & strFileName, %MB_OK OR %MB_ICONERROR, "Error"
'      EXIT SUB
'   END IF

   If strFileName <> "" And PathName$(Path, strFileName) = "" Then strFileName = CurDir$ & "\" & strFileName

   If IsFalse AfxFileExists(strFileName) Then
      CSED_MsgBox hwnd, "Can't find the file " & strFileName, %MB_Ok Or %MB_IconError, "Error"
      Exit Sub
   End If

   DataToSend.lpData  = StrPtr(strFileName)
   DataToSend.cbdata  = Len(strFileName) + 1
   DataToSend.dwData  = Val(strLineNumber) - 1

   SendMessage hwnd, %WM_COPYDATA, Len(DataToSend), VarPtr(DataToSend)
   If pSed.hEdit Then SCI_GotoLine(pSed.hEdit, Val(strLineNumber) - 1)

End Sub
' ========================================================================================

' ========================================================================================
' Default CWindow callback function.
' ========================================================================================
Function CSED_WindowProc (ByVal hwnd As Dword, ByVal uMsg As Dword, ByVal wParam As Dword, ByVal lParam As Long) As Long

   Local r               As Long                   ' // Result code
   Local hwndClient      As Dword                  ' // Handle of the MDI client window
   Local hwndActive      As Dword                  ' // Active window
   Local pnmhdr          As NmHdr Ptr              ' // Information about a notification message
   Local hMdi            As Dword                  ' // MDI child window handle
   Local hToolBar        As Dword                  ' // Toolbar handle
   Local hBottomToolBar  As Dword                  ' // Toolbar handle
   Local ptbn            As TBNOTIFY Ptr           ' // For toolbar notification messages
   Local hTabMdi         As Dword                  ' // Tab control handle
   Local hStatusBar      As Dword                  ' // Statusbar handle
   Local rc              As RECT                   ' // RECT structure
   Local nTab            As Dword                  ' // Tab number
   Local PID             As Dword                  ' // Process identifier
   Local hCalc           As Dword                  ' // Calculator handle
   Local curPos          As Long                   ' // Current position
   Local endPos          As Long                   ' // Ending position
   Local curSel          As Long                   ' // Current selection
   Local pttdi           As NMTTDISPINFO Ptr       ' // Tooltip notification message information
   Local strText         As String                 ' // General purpose variable
   Local strPath         As String                 ' // File path
   Local strFilePath     As String                 ' // File path
   Local vPath           As Variant                ' // File path
   Local pInfo           As TCHITTESTINFO          ' // Information about a hit test
   Local pt              As Point                  ' // Screen coordinates
   Local tProc           As CSED_PROCSTRUCT        ' // Proc structure
   Local hTrackPopUpMenu As Dword                  ' // Track pop up menu handle
   Local pWindow         As IWindow                ' // Reference to the IWindow interface
   Local pQueue          As IQueueCollection       ' // Reference to the Queue collection
   Local pTabFilePaths   As ILinkListCollection    ' // File paths linked list
#If %Def(%UNICODE)
   Local szTooltipText   As WStringZ * %Max_Path   ' // Tooltip text (uicode)
#Else
   Local szTooltipText   As AsciiZ * %Max_Path     ' // Tooltip text
#EndIf

   Static hFocus         As Dword                  ' // Handle of the control that has the focus
   Static dwFindMsg      As Dword                  ' // Registered message handle

   ' // Copy data (for Lynx support)
   Local pDataToGet      As COPYDATASTRUCT Ptr     ' // Pointer to a CopyData structure
   Local pszBuffer       As AsciiZ Ptr             ' // Pointer to the buffer

   ' // Guides menu
   Local hToolsFile     As Long                    ' // Tools file handle
   Local RecordStr      As String                  ' // Record string
   Local tTools         As CSED_TOOLSTYPE          ' // Tools structure

   ' // MDI client window handle
   hwndClient = CWindow_GetMDIClientHandle(hwnd)

   Select Case uMsg

      Case %WM_NCActivate
         ' // Save the handle of the control that has the focus
         If wParam = 0 Then hFocus = GetFocus
         ' // Note: Don't use EXIT FUNCTION

      Case %WM_SetFocus
         ' // Post a message to set the focus later, since some
         ' // Windows actions can steal it if we set it here
         If hFocus Then
            PostMessage hWnd, %WM_User + 999, hFocus, 0
            hFocus = 0
         End If

      Case %WM_User + 999
         ' // Set the focus and show the line an column in the status bar
         If wParam Then SetFocus wParam
         CSED_ShowLinCol   ' // Show line and column
         Exit Function

      Case %WM_User + 1000
         ' // Process the command line
         CSED_ProcessCommandLine hwnd
         Exit Function

      ' // This custom message is posted when the dropdown
      ' // list of the codefinder combobox is closed
      Case %WM_User + 1001
         ' // Reset the contents of the codefinder
         CSED_ResetCodefinder(pSed.hCodeFinderCB)
         ' // Return the focus to the edit control
         SetFocus pSed.hEdit
         Exit Function

      Case %WM_SYSCOMMAND
         ' // Capture this message and send a WM_CLOSE message
         If (wParam And &HFFF0) = %SC_Close Then
            SendMessage hwnd, %WM_Close, 0, 0
            Exit Function
         End If

      Case %WM_SYSCOLORCHANGE
         ' // Menu font size may have changed, so destroy old menu and create a
         ' // new one to use new font's measurements
         If pSed.hMenu = 0 Then pSed.hMenu = GetMenu(hwnd)
         If pSed.hMenu Then
            pWindow = CWindow_GetObjectFromWindowHandle(hwnd)
            If IsObject(pWindow) Then
               DestroyMenu pSed.hMenu
               pSed.hMenu = CSED_CreateMenu(pWindow)
               pWindow = Nothing
            End If
         End If
         ' // Forward this message to common controls so that they will
         ' // be properly updated if the user changes the color settings.
         SendMessage pSed.hToolbar, %WM_SYSCOLORCHANGE, wParam, lParam
         SendMessage pSed.hStatusbar, %WM_SYSCOLORCHANGE, wParam, lParam

      Case %WM_DROPFILES
         ' // Retrieve the dropped file names
         pQueue = CSED_GetDroppedFiles(wParam)
         ' Open a new edit window for each of them
         If IsObject(pQueue) Then
            If pQueue.Count Then
               Do
                  vPath = pQueue.Dequeue
                  If ObjResult Then Exit Do
                  If VariantVT(vPath) <> %VT_Empty Then CSED_OpenFile(Variant$$(vPath))
               Loop
            End If
         End If
         Exit Function

      Case %WM_COPYDATA
         ' // For Lynx support
         pDataToGet = lParam
         pszBuffer = @pDataToGet.lpData
         CSED_OpenFile Trim$(@pszBuffer)
         SCI_GotoLine(pSed.hEdit, SCI_GetTextLength(pSed.hEdit))
         SCI_GotoLine(pSed.hEdit, @pDataToGet.dwData)

      Case %WM_Command

         Select Case Lo(Word, wParam)

            Case %IdCancel
               If Hi(Word, wParam) = %BN_Clicked Then
                  SendMessage hwnd, %WM_Close, 0, 0
                  Exit Function
               End If

            ' *** FILE_MENU_BEGIN ***
            ' // New file
            Case %IDM_NEW
               If pSed.hEdit Then UpdateWindow(pSed.hEdit)
               hMdi = CSED_CreateMdiChild("Untitled" & Format$(pSed.UntitledFilesIdx) & ".bas")
               CSED_ResetCodeFinder(pSed.hCodeFinderCB)
               ShowWindow hMdi, %SW_Show
               Exit Function

             ' // Insert file
            Case %IDM_INSERTFILE
               If pSed.hEdit Then UpdateWindow(pSed.hEdit)
               CSED_InsertFile hwnd
               Exit Function

            ' // Open file
            Case %IDM_OPEN
               CSED_OpenFileDialog(hwnd)
               CSED_ChangeToolbarButtonsState
               CSED_ChangeMenuItemsState
               Exit Function

            ' // Open recent file
            Case %IDM_RECENTFILE1 To %IDM_RECENTFILE9
               CSED_OpenRecentFile wParam
               Exit Function

            ' // Save
            Case %IDM_SAVE
               If pSed.hEdit Then UpdateWindow(pSed.hEdit)
               CSED_SaveFile hwnd, pSed.hEdit, %FALSE
               CSED_ChangeToolbarButtonsState
               CSED_ChangeMenuItemsState
               Exit Function

            ' // Save as
            Case %IDM_SAVEAS
               If pSed.hEdit Then UpdateWindow(pSed.hEdit)
               CSED_SaveFile hwnd, pSed.hEdit, %TRUE
               CSED_ChangeToolbarButtonsState
               CSED_ChangeMenuItemsState
               Exit Function

            ' // Save all files
            Case %IDM_SAVEALL
               If pSed.hEdit Then UpdateWindow(pSed.hEdit)
               CSED_SaveLoadedFiles hwnd
               CSED_ChangeMenuItemsState
               Exit Function

            ' // Close file
            Case %IDM_CLOSEFILE, %IDM_CLOSEWINDOW
               If pSed.hEdit Then UpdateWindow(pSed.hEdit)
               ' // Get the path of the file from the window caption
               strPath = AfxGetWindowText(MdiGetActive(pSed.hwndClient))
               ' // See if the document has been modified
               If SCI_GetModify(pSed.hEdit) Then
                  Beep
                  r = CSED_MsgBox(hwnd, "Save current changes? " & PathName$(Namex, strPath), _
                           %MB_YesNoCancel Or %MB_IconQuestion)
                  If r = %IdCancel Then Exit Function
                  If r = %IdYes Then
                     r = CSED_SaveFile(hwnd, pSed.hEdit, %FALSE)
                     If r = 0 Then Exit Function
                  End If
               End If
               ' // Close the active window
               If hwndClient Then
                  hwndActive = MdiGetActive(hwndClient)
                  If SendMessage(hwndActive, %WM_QUERYENDSESSION, 0, 0) Then
                     MdiDestroy(hwndClient, hwndActive)
                  End If
               End If
               CSED_ChangeToolbarButtonsState
               CSED_ChangeMenuItemsState
               ' // Enable open just in case it has been disabled
               EnableMenuItem pSed.hMenuFile, %IDM_OPEN, %MF_Enabled
               Toolbar_EnableButton(pSed.hToolbar, %IDM_OPEN)
               ' // If there are not child windows open, clear the status bar
               If GetWindow(hwndClient, %GW_CHILD) = 0 Then CSED_ClearStatusBar
               Exit Function

            ' // Close all
            Case %IDM_CLOSEALL, %IDM_CLOSEWINDOWS
               ' // Close all the MDI child windows
               If hwndClient Then
                  EnumChildWindows hwndClient, CodePtr(CSED_CloseEnumProc), 0
               End If
               CSED_ChangeToolbarButtonsState
               CSED_ChangeMenuItemsState
               ' // Enable open just in case it has been disabled
               EnableMenuItem pSed.hMenuFile, %IDM_OPEN, %MF_Enabled
               Toolbar_EnableButton(pSed.hToolbar, %IDM_OPEN)
               ' // If there are not child windows open, clear the status bar
               If GetWindow(hwndClient, %GW_CHILD) = 0 Then CSED_ClearStatusBar
               Exit Function

            ' // DOS prompt
            Case %IDM_DOS
               PID = Shell(Environ$("COMSPEC"))
               Exit Function

            ' // Refresh document
            Case %IDM_REFRESH
               If pSed.hEdit Then UpdateWindow(pSed.hEdit)
               strPath = AfxGetWindowText(MdiGetActive(pSed.hwndClient))
               If Left$(UCase$(PathName$(Namex, strPath)), 8) <> "UNTITLED" Then
                  CSED_OpenFile strPath
               End If
               Exit Function

            ' *** FILE_MENU_END ***

            ' *** EDIT_MENU_BEGIN ***
            ' // Undo
            Case %IDM_UNDO
               SCI_Undo(pSed.hEdit)
               CSED_ChangeToolbarButtonsState
               CSED_ChangeMenuItemsState
               Exit Function

            ' // Redo
            Case %IDM_REDO
               SCI_Redo(pSed.hEdit)
               CSED_ChangeToolbarButtonsState
               CSED_ChangeMenuItemsState
               Exit Function

            ' // Clear
            Case %IDM_CLEAR
               SCI_Clear(pSed.hEdit)
               Exit Function

            ' // Clear all
            Case %IDM_CLEARALL
               SCI_ClearAll(pSed.hEdit)
               Exit Function

            ' // Cut
            Case %IDM_CUT
               SCI_Cut(pSed.hEdit)
               Exit Function

            ' // Copy
            Case %IDM_COPY
               SCI_Copy(pSed.hEdit)
               Exit Function

            ' // Paste
            Case %IDM_PASTE
               SCI_Paste(pSed.hEdit)
               CSED_ChangeToolbarButtonsState
               CSED_ChangeMenuItemsState
               Exit Function

            ' // Delete line
            Case %IDM_LINEDELETE
               SCI_LineDelete(pSed.hEdit)
               Exit Function

            ' // Select all
            Case %IDM_SELECTALL
               SCI_SelectAll(pSed.hEdit)
               Exit Function

            ' // Indent block
            Case %IDM_BLOCKINDENT
               SCI_Tab(pSed.hEdit)
               Exit Function

            ' // Unindent block
            Case %IDM_BLOCKUNINDENT
               SCI_BackTab(pSed.hEdit)
               Exit Function

            ' // Comment line or blobk
            Case %IDM_COMMENT, %IDK_COMMENT
               SCI_BlockComment(pSed.hEdit)
               Exit Function

            ' // Uncomment line or blobk
            Case %IDM_UNCOMMENT, %IDK_UNCOMMENT
               SCI_BlockUncomment(pSed.hEdit)
               Exit Function

            ' // Convert selected text to upper case
            Case %IDM_SELTOUPPERCASE
               SCI_ChangeSelectionToUpperCase(pSed.hEdit)
               Exit Function

            ' // Convert selected text to lower case
            Case %IDM_SELTOLOWERCASE
               SCI_ChangeSelectionToLowerCase(pSed.hEdit)
               Exit Function

            ' Convert selected text to mixed case
            Case %IDM_SELTOMIXEDCASE
               SCI_ChangeSelectionToMixedCase(pSed.hEdit)
               Exit Function

            ' // Change end of line to <cr> <lf>
            Case %IDM_CVEOLTOCRLF
               SCI_ConvertEOLs(pSed.hEdit, %SC_EOL_CRLF)
               Exit Function

            ' // Change end of line to <cr>
            Case %IDM_CVEOLTOCR
               SCI_ConvertEOLs(pSed.hEdit, %SC_EOL_CR)
               Exit Function

            ' // Change end of line to <lf>
            Case %IDM_CVEOLTOLF
               SCI_ConvertEOLs(pSed.hEdit, %SC_EOL_LF)
               Exit Function

            ' // Goto to the specified line
            Case %IDM_GOTOLINE
               CSED_GotoLineDialog hwnd
               Exit Function

            ' // Replace tabs with spaces
            Case %IDM_REPLTABSWITHSPC
               SCI_ReplaceTabsWithSpaces(pSed.hEdit)
               Exit Function

            ' // Format selected text
            Case %IDM_FORMATREGION
               SCI_FormatRegion(pSed.hEdit)
               Exit Function

            ' // Tabulate selected text
            Case %IDM_TABULATEREGION
               SCI_TabulateRegion(pSed.hEdit)
               Exit Function

            ' // Goto to the beginning of the first procedure
            Case %IDM_GOTOBEGINPROC
               curPos = CSED_GotoBeginProc
               Exit Function

            ' // Goto to the end of the last procedure
            Case %IDM_GOTOENDPROC
               curPos = CSED_GotoEndProc
               Exit Function

            ' // Goto to the beginning of the procedure
            Case %IDM_GOTOBEGINTHISPROC
               curPos = CSED_GotoBeginThisProc
               Exit Function

            ' // Goto to the end of the procedure
            Case %IDM_GOTOENDTHISPROC
               curPos = CSED_GotoEndThisProc
               Exit Function

            ' // Generate a new guid and insert it at the cursor location
            Case %IDM_INSERTGUID
               strText = "GUID$(" & $Dq & GuidTxt$(Guid$) & $Dq & ")"
               SCI_InsertText(pSed.hEdit, -1, strText)
               Exit Function

            ' // Change directory to current file path
            Case %IDM_CHDIR
               strPath = AfxGetWindowText(MdiGetActive(pSed.hwndClient))
               strPath = PathName$(Path, strPath)
               If Right$(strPath, 1) = "\" Then strPath = Left$(strPath, Len(strPath) - 1)
               If Len(strPath) Then ChDir strPath
               Exit Function

            ' // Keyboard macros
            Case %IDM_ALT0 To %IDM_ALT9, %IDM_CTRL0 To %IDM_CTRL9
               CSED_InsertMacroText Lo(Word, hwnd), wParam
               Exit Function
            ' *** EDIT_MENU_END ***

            ' *** SEARCH_MENU_BEGIN ***
            ' // Toggle the current bookmark
            Case %IDM_TOGGLEBOOKMARK
               SCI_ToggleBookmark(pSed.hEdit)
               ' // Comment and uncomment the line just to make
               ' // the file dirty and force saving.
               SCI_BlockComment(pSed.hEdit)
               SCI_BlockUncomment(pSed.hEdit)
               Exit Function

            ' // Goto next bookmark
            Case %IDM_NEXTBOOKMARK
               SCI_NextBookmark(pSed.hEdit)
               Exit Function

            ' // Goto previous bookmark
            Case %IDM_PREVIOUSBOOKMARK
               SCI_PrevBookmark(pSed.hEdit)
               Exit Function

            ' // Delete bookmarks
            Case %IDM_DELETEBOOKMARKS
               SCI_DeleteBookmark(pSed.hEdit)
               Exit Function

            ' // Code finder combobox
            Case %IDM_CODEFINDER
               SendMessage pSed.hCodeFinderCB, %CB_SHOWDROPDOWN, %TRUE, 0
               SetFocus pSed.hCodeFinderCB
'               ComboBox_SetCurSel pSed.hCodeFinderCB, 0
               Exit Function

            ' // Launch Explorer
            Case %IDM_EXPLORER
               ShellExecute %HWND_Desktop, "explore", ByCopy CurDir$, ByVal 0, ByVal 0, %SW_ShowNormal
               Exit Function

            ' // Launch Windows Find
            Case %IDM_WINDOWSFIND
               ShellExecute %HWND_Desktop, "find", ByCopy CurDir$, ByVal 0, ByVal 0, %SW_ShowNormal
               Exit Function
            ' *** SEARCH_MENU_END ***

            ' *** VIEW_MENU_BEGIN ***

            ' // Toggle current fold point
            Case %IDM_TOGGLE
               SCI_ToggleCurFold(pSed.hEdit, SCI_GetCurrentLineNumber(pSed.hEdit))
               Exit Function

            ' // Toggle all current fold point from current to below
            Case %IDM_TOGGLEALL
               SCI_ToggleFoldsOnwards(pSed.hEdit, SCI_GetCurrentLineNumber(pSed.hEdit))
               Exit Function

            ' // Fold all the fold points
            Case %IDM_FOLDALL
               SCI_FoldAll(pSed.hEdit)
               Exit Function

            ' // Unfold all the fold points
            Case %IDM_UNFOLDALL
               SCI_UnfoldAll(pSed.hEdit)
               Exit Function

            ' // Toggle the Use Tabs option
            Case %IDM_USETABS
               If pSed.hEdit Then
                  If pSed.UseTabs Then
                     pSed.UseTabs = %FALSE
                     SCI_SetUseTabs(pSed.hEdit, %FALSE)
                  Else
                     pSed.UseTabs = %TRUE
                     SCI_SetUseTabs(pSed.hEdit, %TRUE)
                  End If
               End If
               Exit Function

            ' // Toggle the Autoindent option
            Case %IDM_AUTOINDENT
               If pSed.hEdit Then
                  If pSed.AutoIndent Then
                     pSed.AutoIndent = %FALSE
                  Else
                     pSed.AutoIndent = %TRUE
                  End If
               End If
               Exit Function

            ' // Toggle the End of Line option
            Case %IDM_SHOWEOL
               If pSed.hEdit Then
                  If pSed.EndOfLine Then
                     pSed.EndOfLine = %FALSE
                     SCI_SetViewEOL(pSed.hEdit, %FALSE)
                  Else
                     pSed.EndOfLine = %TRUE
                     SCI_SetViewEOL(pSed.hEdit, %TRUE)
                  End If
               End If
               Exit Function

            ' // Toggle the Line Numbers option
            Case %IDM_SHOWLINENUM
               If pSed.hEdit Then
                  If pSed.LineNumbers Then
                     pSed.LineNumbers = %FALSE
                     SCI_SetMarginWidthN(pSed.hEdit, 0, 0)
                  Else
                     pSed.LineNumbers = %TRUE
                     If SCI_GetMarginWidthN(pSed.hEdit, 0) = 0 Then
                        If pSed.LineNumbersWidth = 0 Then pSed.LineNumbersWidth = 50
                        SCI_SetMarginWidthN(pSed.hEdit, 0, pSed.LineNumbersWidth)
                     End If
                  End If
               End If
               Exit Function

            ' // Toggle the Margin option
            Case %IDM_SHOWMARGIN
               If pSed.hEdit Then
                  If pSed.Margin Then
                     pSed.Margin = %FALSE
                     SCI_SetMarginWidthN(pSed.hEdit, 2, 0)
                  Else
                     pSed.Margin = %TRUE
                     If SCI_GetMarginWidthN(pSed.hEdit, 2) = 0 Then
                        If pSed.MarginWidth = 0 Then pSed.MarginWidth = 20
                        SCI_SetMarginWidthN(pSed.hEdit, 2, pSed.MarginWidth)
                     End If
                  End If
               End If
               Exit Function

            ' // Toggle the Use Tabs option
            Case %IDM_SHOWINDENT
               If pSed.hEdit Then
                  If pSed.IndentGuides Then
                     pSed.IndentGuides = %FALSE
                     SCI_SetIndentationGuides(pSed.hEdit, %SC_IV_NONE)
                  Else
                     pSed.IndentGuides = %TRUE
                     SCI_SetIndentationGuides(pSed.hEdit, %SC_IV_REAL)
                  End If
               End If
               Exit Function

            ' // Toggle the End of Line option
            Case %IDM_SHOWEOL
               If pSed.hEdit Then
                  If pSed.EndOfLine Then
                     pSed.EndOfLine = %FALSE
                     SCI_SetViewEOL(pSed.hEdit, %FALSE)
                  Else
                     pSed.EndOfLine = %TRUE
                     SCI_SetViewEOL(pSed.hEdit, %TRUE)
                  End If
               End If
               Exit Function

            ' // Toggle the WhiteSpace option
            Case %IDM_SHOWSPACES
               If pSed.hEdit Then
                  If pSed.WhiteSpace Then
                     pSed.WhiteSpace = %FALSE
                     SCI_SetViews(pSed.hEdit, %SCWS_INVISIBLE)
                  Else
                     pSed.WhiteSpace = %TRUE
                     SCI_SetViews(pSed.hEdit, %SCWS_VISIBLEALWAYS)
                  End If
               End If
               Exit Function

            ' // Toggle the Edge option
            Case %IDM_SHOWEDGE
               If pSed.hEdit Then
                  If pSed.EdgeColumn Then
                     pSed.EdgeColumn = %FALSE
                     SCI_SetEdgeMode(pSed.hEdit, %EDGE_NONE)
                  Else
                     pSed.EdgeColumn = %TRUE
                     SCI_SetEdgeMode(pSed.hEdit, %EDGE_LINE)
                  End If
               End If
               Exit Function

            ' // Zoom in
            Case %IDM_ZOOMIN
               SCI_ZoomIn(pSed.hEdit)
               Exit Function

            ' // Zoom out
            Case %IDM_ZOOMOUT
               SCI_ZoomOut(pSed.hEdit)
               Exit Function

            ' // File properties
            Case %IDM_FILEPROPERTIES
               If hwndClient Then AfxShowFileProperties(hwnd, AfxGetWindowText(MdiGetActive(hwndClient)))
               Exit Function

            ' // System information
            Case %IDM_SYSINFO
               AfxShowSysInfo(hwnd, %TRUE)
               Exit Function
            ' *** VIEW_MENU_END ***

            ' *** WINDOW_MENU_BEGIN ***
            ' // Cascade windows
            Case %IDM_CASCADE
               MdiCascade(hwndClient)
               Exit Function

            ' // Tile horizontal
            Case %IDM_TILEH
               MdiTileHorizontal(hwndClient)
               Exit Function

            ' // Tile vertical
            Case %IDM_TILEV
               MdiTileVertical(hwndClient)
               Exit Function

            ' // Arrange icons
            Case %IDM_ARRANGE
               MdiIconArrange(hwndClient)
               Exit Function

            ' // Restore the size of the main window
            Case %IDM_RESTOREWSIZE
               SystemParametersInfo %SPI_GETWORKAREA, 0, rc, 0
               MoveWindow hwnd, 0, 0, rc.Right - rc.Left, rc.Bottom - rc.Top, %TRUE
               AfxCenterWindow hwnd
               Exit Function

            ' // Swicth window
            Case %IDM_SWITCHWINDOW
               hwndActive = MdiGetActive(pSed.hwndClient)
               MdiNext(pSed.hwndClient, hwndActive, 0)
               strPath = AfxGetWindowText(MdiGetActive(pSed.hwndClient))
               nTab = CSED_GetTabNumberFromPath(strPath)
               If nTab > -1 Then TabCtrl_SetCursel(pSed.hTabMdi, nTab)
               Exit Function
            ' *** WINDOW_MENU_END ***

            ' *** TOOLS_MENU_END ***
            ' // Tools dialog
            Case %IDM_TOOLS
               If IsFile(Exe.Path$ & "CSED_TOOLS\CSED_TOOLS.EXE") Then PID = Shell(Exe.Path$ & "CSED_TOOLS\CSED_TOOLS.EXE", 1)
               Exit Function

            ' // Code keeper
            Case %IDM_CODEKEEPER
               If IsFile(Exe.Path$ & "CSED_CODEKEEPER\CSED_CODEKEEPER.EXE") Then PID = Shell(Exe.Path$ & "CSED_CODEKEEPER\CSED_CODEKEEPER.EXE", 1)
               Exit Function

            ' // Keyboard macros
            Case %IDM_KBDMACROS
               If IsFile(Exe.Path$ & "CSED_KBDMACROS\CSED_KBDMACROS.EXE") Then PID = Shell(Exe.Path$ & "CSED_KBDMACROS\CSED_KBDMACROS.EXE", 1)
               Exit Function

            ' // Code tips builder
            Case %IDM_CODETIPSBUILDER
               If IsFile(Exe.Path$ & "CSED_CODETIPS\CSED_CODETIPS.EXE") Then PID = Shell(Exe.Path$ & "CSED_CODETIPS\CSED_CODETIPS.EXE", 1)
               Exit Function

            ' // Launch PBForms
            Case %IDM_PBFORMS
               strPath = pSed.PBFormsPath
               If Len(strPath) Then
                  If pSed.hEdit Then UpdateWindow pSed.hEdit
                  CSED_SaveFile hwnd, pSed.hEdit, %FALSE
                  strFilePath = AfxGetWindowText(MdiGetActive(pSed.hwndClient))
                  If Len(strPath) Then r = Shell(strPath & " " & strFilePath, 1)
               End If
               Exit Function

            ' // Launch the PB COM browser
            Case %IDM_PBCOMBR
               strPath = pSed.PBCOMBrowserPath
               If Len(strPath) Then r = Shell(strPath, 1)
               Exit Function

            ' // Launch the PB Library Manager
            Case %IDM_POWERLIB
               strPath = pSed.PowerLibPath
               If Len(strPath) Then r = Shell(strPath, 1)
               Exit Function

            ' // Launch the TypeLib Browser
            Case %IDM_TYPELIBBR
               strPath = pSed.TypeLibBrowserPath
               If Len(strPath) Then r = Shell(strPath, 1)
               Exit Function

            ' // Debugging tool
            Case %IDM_DEBUGTOOL
               strPath = pSed.DebugToolPath
               If Len(strPath) Then r = Shell(strPath, 1)
               Exit Function

            ' // Find in files
            Case %IDM_FINDINFILES
               strPath = pSed.FindInFilesToolPath
               If Len(strPath) Then r = Shell(strPath, 1)
               Exit Function

            ' // Launch the Windows calculator
            Case %IDM_CALCULATOR
               hCalc = FindWindow("SciCalc", ByVal %NULL)
               If hCalc <> %NULL Then
                  If IsIconic(hCalc) <> 0 Or IsZoomed(hCalc) <> 0 Then
                     ShowWindow hCalc, %SW_Restore
                  End If
                  SetForegroundWindow hCalc
               Else
                  r = Shell("CALC.EXE")
               End If
               Exit Function

            ' // Character map
            Case %IDM_CHARMAP
               r = Shell("CharMap.exe")
               Exit Function

            ' // Notepad
            Case %IDM_NOTEPAD
               r = Shell("Notepad.exe")
               Exit Function

            ' // Microsoft Paint
            Case %IDM_MSPAINT
               r = Shell("mspaint.exe")
               Exit Function

            ' // Lynx
            Case %IDM_LYNX
               If IsFile(Exe.Path$ & "CSED_LYNX\Lynx.exe") Then PID = Shell(Exe.Path$ & "CSED_LYNX\Lynx.exe", 1)
               Exit Function

            ' // Message box designer
            Case %IDM_MSGBOXDESIGNER
               If IsFile(Exe.Path$ & "MessageBoxDesigner\MessageBoxDesigner.exe") Then PID = Shell(Exe.Path$ & "MessageBoxDesigner\MessageBoxDesigner.exe", 1)
               Exit Function

            ' // Backup files manager
            Case %IDM_BACKUPMGR
               If IsFile(Exe.Path$ & "CSED_BACKUPMGR\CSED_BACKUPMGR.exe") Then PID = Shell(Exe.Path$ & "CSED_BACKUPMGR\CSED_BACKUPMGR.exe", 1)
               Exit Function

            ' // File stamp
            Case %IDM_FILESTAMP
               If IsFile(Exe.Path$ & "FileStamp\fStamp.exe") Then PID = Shell(Exe.Path$ & "FileStamp\fStamp.exe", 1)
               Exit Function

            ' // Visual designer
            Case %IDM_VISDES
               strPath = pSed.VisualDesignerPath
               If Len(strPath) Then r = Shell(strPath, 1)
               Exit Function

            ' // Icon editor
            Case %IDM_ICONED
               strPath = pSed.IconEditorPath
               If Len(strPath) Then r = Shell(strPath, 1)
               Exit Function

            ' // Image editor
            Case %IDM_IMGED
               strPath = pSed.ImageEditorPath
               If Len(strPath) Then r = Shell(strPath, 1)
               Exit Function

            ' // Selected headers
            Case %IDM_JRSINC1
               pSed.SelectedHeaders = 1
               Exit Function
            Case %IDM_JRSINC2
               pSed.SelectedHeaders = 2
               Exit Function
            Case %IDM_PBINC1
               pSed.SelectedHeaders = 3
               Exit Function
            Case %IDM_PBINC2
               pSed.SelectedHeaders = 4
               Exit Function

            ' *** TOOLS_MENU_END ***

            ' // Autocompletion listbox
            Case %IDM_AUTOCOMPLETE
               CSED_AutoComplete(hwnd)
               Exit Function

            ' // Toggle the Show Procedure Name option
            Case %IDM_SHOWPROCNAME
               If pSed.ShowProcedureName = %BST_CHECKED Then
                  CheckMenuItem pSed.hMenu, %IDM_SHOWPROCNAME, %MF_UnChecked
                  pSed.ShowProcedureName = %BST_UNCHECKED
                  StatusBar_SetText(pSed.hStatusbar, 4, "")
               Else
                  CheckMenuItem pSed.hMenu, %IDM_SHOWPROCNAME, %MF_Checked
                  pSed.ShowProcedureName = %BST_CHECKED
                  CSED_WithinProc(tProc)
                  StatusBar_SetText(pSed.hStatusbar, 4, tProc.ProcName)
               End If
               Exit Function

            ' // Toggle compiler selection
            Case %IDM_TOGGLECOMPILER
               If pSed.SelectedCompiler = 2 Then
                  pSed.SelectedCompiler = 1
                  StatusBar_SetText(pSed.hStatusbar, 3, "PBWIN")
               Else
                  pSed.SelectedCompiler = 2
                  StatusBar_SetText(pSed.hStatusbar, 3, "PBCC")
               End If
               Exit Function

            ' // Convert to HTML
            Case %IDM_HTMLCODE
               If pSed.hEdit Then UpdateWindow pSed.hEdit
               CSED_CvBasToHtml(%TRUE)
               Exit Function

            ' // HTML Print preview
            Case %IDM_PRINT
               If pSed.hEdit Then UpdateWindow pSed.hEdit
               strText = CSED_CvBasToHtml(%FALSE, %TRUE)
               If Len(strText) Then CSED_WB_PrintPreview(hwnd, strText)
               Exit Function

            ' // Editor options
            Case %IDM_EDITOROPT
               CSED_EditorOptionsDialog hwnd
               Exit Function

            ' // Compiler options
            Case %IDM_COMPILEROPT
               CSED_CompilerOptionsDialog hwnd
               Exit Function

            ' // Fold options
            Case %IDM_FOLDOPT
               CSED_FoldOptionsDialog hwnd
               Exit Function

            ' // Fold options
            Case %IDM_COLORSOPT
               CSED_ColorOptionsDialog hwnd
               Exit Function

            ' // Register file extensions
            Case %IDM_REGFILEEXT
               CSED_RegisterFileExtensions hwnd
               Exit Function

            ' // Email us
            Case %IDM_MAIL
               strText = "mailto:" & $MAILADDRESS & "?"
               ShellExecute ByVal %NULL, "open", ByCopy strText, ByVal %NULL, ByVal %NULL, %SW_ShowNormal
               Exit Function

            ' // Exit
            Case %IDM_EXIT
               SendMessage hwnd, %WM_Close, 0, 0
               Exit Function

            ' *** HELP_MENU_BEGIN ***
            ' // About box
            Case %IDM_ABOUT
               CSED_AboutBox hwnd
               Exit Function

            ' // Context help
            Case %IDM_HELP
               CSED_SearchContextHelp hwnd
               Exit Function

            ' // CSED help
            Case %IDM_CSEDHELP
               strPath = Exe.Path$ & "CSED.CHM"
               If IsFile(strPath) Then HtmlHelp 0, ByCopy strPath, 0, 0
               Exit Function

            ' // PBWIN help
            Case %IDM_PBWINHELP
               strPath = pSed.PBWinHelpPath
               If Len(strPath) Then
                  If Right$(UCase$(strPath), 4) = ".HLP" Then
                     WinHelp hwnd, ByCopy strPath, %HELP_FINDER, 0
                  ElseIf Right$(UCase$(strPath), 4) = ".CHM" Then
                     HtmlHelp 0, ByCopy strPath, 0, 0
                  End If
               End If
               Exit Function

            ' // PBCC help
            Case %IDM_PBCCHELP
               strPath = pSed.PBCCHelpPath
               If Len(strPath) Then
                  If Right$(UCase$(strPath), 4) = ".HLP" Then
                     WinHelp hwnd, ByCopy strPath, %HELP_FINDER, 0
                  ElseIf Right$(UCase$(strPath), 4) = ".CHM" Then
                     HtmlHelp 0, ByCopy strPath, 0, 0
                  End If
               End If
               Exit Function

            ' // Help contents
            Case %IDM_HELPCONTENTS
               If pSed.SelectedCompiler = 1 Then
                  strPath = pSed.PBWinHelpPath
               Else
                  strPath = pSed.PBCCHelpPath
               End If
               If Len(strPath) Then
                  If Right$(UCase$(strPath), 4) = ".HLP" Then
                     WinHelp hwnd, ByCopy strPath, %HELP_CONTENTS, 0
                  ElseIf Right$(UCase$(strPath), 4) = ".CHM" Then
                     HtmlHelp 0, ByCopy strPath, %HH_DISPLAY_TOC, 0
                  End If
               End If
               Exit Function

            ' // Help index
            Case %IDM_HELPINDEX
               If pSed.SelectedCompiler = 1 Then
                  strPath = pSed.PBWinHelpPath
               Else
                  strPath = pSed.PBCCHelpPath
               End If
               If Len(strPath) Then
                  If Right$(UCase$(strPath), 4) = ".HLP" Then
                     WinHelp hwnd, ByCopy strPath, %HELP_INDEX, 0
                  ElseIf Right$(UCase$(strPath), 4) = ".CHM" Then
                     HtmlHelp 0, ByCopy strPath, %HH_DISPLAY_INDEX, 0
                  End If
               End If
               Exit Function

            ' // Help search
            Case %IDM_HELPSEARCH
               If pSed.SelectedCompiler = 1 Then
                  strPath = pSed.PBWinHelpPath
               Else
                  strPath = pSed.PBCCHelpPath
               End If
               If Len(strPath) Then
                  If Right$(UCase$(strPath), 4) = ".HLP" Then
                     WinHelp hwnd, ByCopy strPath, %HELP_FINDER, 0
                  ElseIf Right$(UCase$(strPath), 4) = ".CHM" Then
                     Local q As HH_FTS_QUERY
                     q.cbStruct = SizeOf(q)
                     HtmlHelp 0, ByCopy strPath, %HH_DISPLAY_SEARCH, VarPtr(q)
                  End If
               End If
               Exit Function

            ' // Guides
            Case %IDM_GUIDESMENUHEADER + 1 To %IDM_GUIDESMENUHEADER + pSed.MenuGuidesCount
               strText = AfxGetMenuItemText(pSed.hMenuGuides, Lo(Word, wParam))
               ' // Retrieve the path of the help file
               hToolsFile = trm_Open(Exe.Path$ & "CSED_TOOLS\CSED_TOOLS.TRM", %TRUE)
               If hToolsFile Then
                  RecordStr = trm_GetEqual(hToolsFile, 1, ByCopy strText)
                  LSet tTools = RecordStr
                  strPath = Trim$(tTools.strPath)
                  If Len(strPath) Then
                     If UCase$(Right$(Trim$(tTools.strPath), 4)) = ".CHM" Then
                        HtmlHelp( 0, ByCopy strPath, 0, 0)
                     ElseIf UCase$(Right$(Trim$(tTools.strPath), 4)) = ".PDF" Then
                        ShellExecute(%NULL, "open", ByCopy Trim$(tTools.strPath), ByCopy Trim$(tTools.strParams), "", %SW_ShowNormal)
                     End If
                  End If
                  ' // Close the file
                  trm_Close hToolsFile
               End If
               Exit Function

            ' // Tools
            Case %IDM_TOOLSMENUHEADER + 1 To %IDM_TOOLSMENUHEADER + pSed.MenuToolsCount
               strText = AfxGetMenuItemText(pSed.hMenuTools, Lo(Word, wParam))
               ' // Retrieve the path of the help file
               hToolsFile = trm_Open(Exe.Path$ & "CSED_TOOLS\CSED_TOOLS.TRM", %TRUE)
               If hToolsFile Then
                  RecordStr = trm_GetEqual(hToolsFile, 1, ByCopy strText)
                  LSet tTools = RecordStr
                  strPath = Trim$(tTools.strPath)
                  If Len(strPath) Then
                     If UCase$(Right$(Trim$(tTools.strPath), 4)) <> ".CHM" Then
                        PID = Shell(strPath & " " & Trim$(tTools.strParams), 1)
                     End If
                  End If
                  ' // Close the file
                  trm_Close hToolsFile
               End If
               Exit Function

            ' // Jos Roca Software site
            Case %IDM_JRSSITE
               ShellExecute %HWND_Desktop, "open", "http://www.jose.it-berater.org/index.html", ByVal 0, ByVal 0, %SW_ShowNormal
               Exit Function

            ' // Jos Roca Software forum
            Case %IDM_JRSFORUM
               ShellExecute %HWND_Desktop, "open", "http://www.jose.it-berater.org/smfforum/index.php", ByVal 0, ByVal 0, %SW_ShowNormal
               Exit Function

            ' // PowewrBASIC site
            Case %IDM_PBSITE
               ShellExecute %HWND_Desktop, "open", "http://www.powerbasic.com", ByVal 0, ByVal 0, %SW_ShowNormal
               Exit Function

            ' // MSDN site
            Case %IDM_MSDNSITE
               ShellExecute %HWND_Desktop, "open", "http://msdn.microsoft.com", ByVal 0, ByVal 0, %SW_ShowNormal
               Exit Function

            ' // Google
            Case %IDM_GOOGLE
               ShellExecute %HWND_Desktop, "open", "http://www.google.com", ByVal 0, ByVal 0, %SW_ShowNormal
               Exit Function

            ' // Google code search
            Case %IDM_GOOGLECODESEARCH
               ShellExecute %HWND_Desktop, "open", "http://www.google.com/codesearch", ByVal 0, ByVal 0, %SW_ShowNormal
               Exit Function

            ' // Resource compiler help
            Case %IDM_RCHELP
               ShellExecute %HWND_Desktop, "open", "http://msdn.microsoft.com/en-us/library/aa381042%28VS.85%29.aspx", ByVal 0, ByVal 0, %SW_ShowNormal
               Exit Function

            ' // Platform SDK Help
            Case %IDM_PLATFORMSDKHELP
               CSED_MSDNHELP hwnd
               Exit Function

            ' *** HELP_MENU_END ***
            ' // Compile and Compile and execute options
            Case %IDM_COMPILE, %IDM_COMPILEANDRUN, %IDM_COMPILEANDDEBUG, %IDM_EXECUTE
               ' // Get the path of the active window
               strPath = AfxGetWindowText(MdiGetActive(pSed.hwndClient))
               ' // If it is a resource file...
               If InStr(UCase$(strPath), ".RC") Then
                  CSED_CompileResource(hwnd, pSed.hEdit, strPath)
                  Exit Function
               End If
               If Lo(Word, wParam) <> %IDM_EXECUTE Then CSED_SaveLoadedFiles(hwnd)
               CSED_CompileBasFile hwnd, pSed.hEdit, Lo(Word, wParam)
               Exit Function

            ' // Run File Dialog
            Case %IDM_RUNFILEDLG
               AfxRunFileDialog hwnd, %NULL, "", "", "", %NULL
               Exit Function

            ' // Compiler results
            Case %IDM_COMPILERRESULTS
               If Len(pSed.CompilerResults) Then CSED_CompilerResults hwnd, pSed.CompilerResults
               Exit Function

            ' // Command line argumtnts
            Case %IDM_COMMANDLINE
               pSed.CommandLine = CWindow_InputBox(hwnd, 0, 0, "Command Line", "Enter command line arguments:", pSed.CommandLine, 256)
               Exit Function

            ' // Code finder combobox
            Case %IDC_CODEFINDER
               Select Case Hi(Word, wParam)
                  Case %CBN_DropDown
                     ' // Search the function and procedure names in a separate procedure.
                     ' // This procedure fills the combobox and stores the lines in the
                     ' // 32-bit values associated with each of them.
                     CSED_CodeFinder(pSed.hCodeFinderCB, pSed.hEdit)
                  Case %CBN_SelChange
                     ' // Retrieve the line of the wanted function or procedure
                     ' // stored in the 32-bit value associated with the specified item.
                     curSel = ComboBox_GetCurSel(pSed.hCodeFinderCB)
                     If curSel Then
                        ' // End position = length of the document
                        endPos = SCI_GetTextLength(pSed.hEdit)
                        ' // Set to end position of document
                        SCI_GotoLine(pSed.hEdit, endPos)
                        ' // Set function or procedure to top of editor
                        curSel = ComboBox_GetItemData(pSed.hCodeFinderCB, curSel)
                        SCI_GotoLine(pSed.hEdit, curSel)
                     End If
                  Case %CBN_CloseUp
                     ' // Post a message to reset the contents
                     PostMessage hwnd, %WM_User + 1001, 0, 0
               End Select
               Exit Function

            ' // Load selected file
            Case %IDM_GOTOSELFILE
               ' // Forward the message to the MDI window procedure
               SendMessage MdiGetActive(pSed.hwndClient), %WM_Command, %IDM_GOTOSELFILE, 0
               Exit Function

            ' // Find and Find and replace
            Case %IDM_FIND, %IDM_REPLACE
               dwFindMsg = pSed.FindReplaceObj.FindOrReplace(hwnd, wParam)
               Exit Function

            ' // Find next
            Case %IDM_FINDNEXT
               pSed.FindReplaceObj.FindNext(hwnd)
               Exit Function

            ' // Find backwards
            Case %IDM_FINDBACKWARDS
               pSed.FindReplaceObj.FindBackwards(hwnd)
               Exit Function

            ' // Common method to find backwards for forward
            Case %IDM_FINDUPORDOWN
               pSed.FindReplaceObj.FindUpOrDown(hwnd)
               Exit Function

         End Select

         ' // Pass unprocessed messages to the active MDI child and then to DefFrameProc()
         hwndActive = SendMessage(hwndClient, %WM_MDIGETACTIVE, 0, 0)
         If IsWindow(hwndActive) Then SendMessage hwndActive, %WM_Command, wParam, lParam

      ' // Message sent by the Find/FindReplace dialog
      Case dwFindMsg
         pSed.FindReplaceObj.FindReplaceText(hwnd)
         Exit Function

      ' // Processes notification messages
      Case %WM_Notify
         pnmhdr = lParam
         Select Case @pnmhdr.idFrom
            Case %IDC_TABMDI
               Select Case @pnmhdr.code
                  Case %NM_Click
                     ' // Get the position of the hit
                     GetCursorPos pInfo.pt
                     ScreentoClient pSed.hTabMdi, pInfo.pt
                     nTab = TabCtrl_HitTest(pSed.hTabMdi, pInfo)
                     ' // If the icon has been clicked...
                     If pInfo.flags = %TCHT_OnItemIcon Then
                        ' // ...send message to close the window
                        SendMessage hwnd, %WM_Command, Mak(Dword, %IDM_CLOSEWINDOW, 0), 0
                     End If
                  Case %NM_RClick
                     ' // Get the tab number
                     GetCursorPos pInfo.pt
                     ScreentoClient pSed.hTabMdi, pInfo.pt
                     nTab = TabCtrl_HitTest(pSed.hTabMdi, pInfo)
                     ' // Select the tab
                     TabCtrl_SetCurSel(pSed.hTabMdi, nTab)
                     ' // Get the path of the file loaded in the associated edit control
                     pTabFilePaths = pSed.TabFilePaths
                     vPath = pTabFilePaths.Item(nTab + 1)
                     ' // Activate it
                     CSED_TabMdiActivateWindow(Variant$$(vPath))
                     ' // Create a popup menu
                     hTrackPopUpMenu = CreatePopUpMenu
                     AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_CLOSEFILE, "&Close" & $Tab & "Ctrl+F4"
                     GetCursorPos pt
                     TrackPopupMenu(hTrackPopUpMenu, 0, pt.x, pt.y, 0, hwnd, ByVal %NULL)
                     DestroyMenu hTrackPopUpMenu
               End Select
            Case %IDC_TOOLBAR
               ptbn = lParam
               If @ptbn.hdr.code = %TBN_DROPDOWN Then
                  Select Case @ptbn.iItem
                     ' // Dropdown new file menu
                     Case %IDM_NEW
                        Toolbar_GetRect(@ptbn.hdr.hwndFrom, @ptbn.iItem, rc)
                        MapWindowPoints(@ptbn.hdr.hwndFrom, %HWND_Desktop, rc, 2)
                        CSED_Templates(hwnd, rc.Left, rc.Bottom)
                     ' // Dropdown open file menu
                     Case %IDM_OPEN
                        Toolbar_GetRect(@ptbn.hdr.hwndFrom, @ptbn.iItem, rc)
                        MapWindowPoints(@ptbn.hdr.hwndFrom, %HWND_Desktop, rc, 2)
                        CSED_RecentFiles(hwnd, rc.Left, rc.Bottom)
                     ' // Dropdown search options menu
                     Case %IDM_FIND
                        Toolbar_GetRect(@ptbn.hdr.hwndFrom, @ptbn.iItem, rc)
                        MapWindowPoints(@ptbn.hdr.hwndFrom, %HWND_Desktop, rc, 2)
                        hTrackPopUpMenu = CreatePopUpMenu
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_FIND, "&Find..." + $Tab + "Ctrl+F"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_FINDNEXT, "Find &Next" + $Tab + "F3"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_FINDBACKWARDS, "Find &Backwards" + $Tab + "Shift+F3"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_REPLACE, "Find and R&eplace..." + $Tab + "Ctrl+R"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_GOTOLINE, "&Go to Line..." + $Tab + "Ctrl+G"
                        TrackPopupMenu(hTrackPopUpMenu, 0, rc.Left, rc.Bottom, 0, hwnd, ByVal %NULL)
                        DestroyMenu hTrackPopUpMenu
                     ' // Dropdown bookmark options menu
                     Case %IDM_BOOKMARKOPTIONS
                        Toolbar_GetRect(@ptbn.hdr.hwndFrom, @ptbn.iItem, rc)
                        MapWindowPoints(@ptbn.hdr.hwndFrom, %HWND_Desktop, rc, 2)
                        hTrackPopUpMenu = CreatePopUpMenu
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_TOGGLEBOOKMARK, "Toggle Bookmark" + $Tab + "Ctrl+F2"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_NEXTBOOKMARK, "Next Bookmark" + $Tab + "F2"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_PREVIOUSBOOKMARK, "Previous Bookmark" + $Tab + "Shift+F2"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_DELETEBOOKMARKS,"Delete Bookmarks" + $Tab + "Ctrl+Shift+F2"
                        TrackPopupMenu(hTrackPopUpMenu, 0, rc.Left, rc.Bottom, 0, hwnd, ByVal %NULL)
                        DestroyMenu hTrackPopUpMenu
                  End Select
               End If
            Case %IDC_BOTTOMTOOLBAR
               ptbn = lParam
               If @ptbn.hdr.code = %TBN_DROPDOWN Then
                  Select Case @ptbn.iItem
                     ' // Dropdown block operations menu
                     Case %IDM_BLOCKOPERATIONS
                        Toolbar_GetRect(@ptbn.hdr.hwndFrom, @ptbn.iItem, rc)
                        MapWindowPoints(@ptbn.hdr.hwndFrom, %HWND_Desktop, rc, 2)
                        hTrackPopUpMenu = CreatePopUpMenu
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_BLOCKINDENT, "Block &Indent" + $Tab + "Tab"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_BLOCKUNINDENT, "Block &Unindent" + $Tab + "Shift+Tab"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_COMMENT, "&Block Comment" + $Tab + "Ctrl+Q"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_UNCOMMENT, "Bloc&k Uncomment" + $Tab + "Ctrl+Shift+Q"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_FORMATREGION, "&Format Text" + $Tab + "Ctrl+B"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_TABULATEREGION, "&Tabulate Text" + $Tab + "Ctrl+Shift+B"
                        TrackPopupMenu(hTrackPopUpMenu, 0, rc.Left, rc.Bottom, 0, hwnd, ByVal %NULL)
                        DestroyMenu hTrackPopUpMenu
                     ' // Dropdown case conversions menu
                     Case %IDM_CASECONVERSIONS
                        Toolbar_GetRect(@ptbn.hdr.hwndFrom, @ptbn.iItem, rc)
                        MapWindowPoints(@ptbn.hdr.hwndFrom, %HWND_Desktop, rc, 2)
                        hTrackPopUpMenu = CreatePopUpMenu
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_SELTOUPPERCASE, "Selection to &Upper Case" + $Tab + "Ctrl+Alt+U"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_SELTOLOWERCASE, "Selection to &Lower Case" + $Tab + "Ctrl+Alt+L"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_SELTOMIXEDCASE, "Selection to &Mixed Case" + $Tab + "Ctrl+Alt+M"
                        TrackPopupMenu(hTrackPopUpMenu, 0, rc.Left, rc.Bottom, 0, hwnd, ByVal %NULL)
                        DestroyMenu hTrackPopUpMenu
                     ' // Dropdown end of line conversions menu
                     Case %IDM_EOLCHARCONVERSIONS
                        Toolbar_GetRect(@ptbn.hdr.hwndFrom, @ptbn.iItem, rc)
                        MapWindowPoints(@ptbn.hdr.hwndFrom, %HWND_Desktop, rc, 2)
                        hTrackPopUpMenu = CreatePopUpMenu
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_CVEOLTOCRLF, "Convert End of Line Characters to $CRLF"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_CVEOLTOCR, "Convert End of Line Characters to $CRLF"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_CVEOLTOLF, "Convert End of Line Characters to $LF"
                        TrackPopupMenu(hTrackPopUpMenu, 0, rc.Left, rc.Bottom, 0, hwnd, ByVal %NULL)
                        DestroyMenu hTrackPopUpMenu
                     ' // Dropdown view options menu
                     Case %IDM_VIEWOPTIONS
                        Toolbar_GetRect(@ptbn.hdr.hwndFrom, @ptbn.iItem, rc)
                        MapWindowPoints(@ptbn.hdr.hwndFrom, %HWND_Desktop, rc, 2)
                        hTrackPopUpMenu = CreatePopUpMenu
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_USETABS, "Use &Tabs" + $Tab + "Ctrl+Shift+T"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_AUTOINDENT, "&Auto Indentation" + $Tab + "Ctrl+Shift+A"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_SHOWLINENUM, "&Line Numbers" + $Tab + "Ctrl+Shift+L"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_SHOWMARGIN, "&Margin" + $Tab + "Ctrl+Shift+M"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_SHOWINDENT, "&Indentation Guides" + $Tab + "Ctrl+Shift+I"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_SHOWSPACES, "&Whitespace" + $Tab + "Ctrl+Shift+W"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_SHOWEOL, "&End of Line" + $Tab + "Ctrl+Shift+D"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_SHOWEDGE, "Ed&ge" + $Tab + "Ctrl+Shift+G"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_SHOWPROCNAME, "&Show Procedure Name" + $Tab + "Ctrl+Shift+S"
                        CSED_CheckMenuOptions(hTrackPopUpMenu)
                        TrackPopupMenu(hTrackPopUpMenu, 0, rc.Left, rc.Bottom, 0, hwnd, ByVal %NULL)
                        DestroyMenu hTrackPopUpMenu
                     ' // Dropdown fold options menu
                     Case %IDM_FOLDOPTIONS
                        Toolbar_GetRect(@ptbn.hdr.hwndFrom, @ptbn.iItem, rc)
                        MapWindowPoints(@ptbn.hdr.hwndFrom, %HWND_Desktop, rc, 2)
                        hTrackPopUpMenu = CreatePopUpMenu
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_TOGGLE, "Toggle &Current Fold Point" + $Tab + "F8"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_TOGGLEALL, "Toggle Current and All &Below" + $Tab + "Ctrl+F8"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_FOLDALL, "&Fold All" + $Tab + "Alt+F8"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_UNFOLDALL, "&Unfold All" + $Tab + "Shift+F8"
                        TrackPopupMenu(hTrackPopUpMenu, 0, rc.Left, rc.Bottom, 0, hwnd, ByVal %NULL)
                        DestroyMenu hTrackPopUpMenu
                     ' // Dropdown PB tools menu
                     Case %IDM_PBFORMS
                        Toolbar_GetRect(@ptbn.hdr.hwndFrom, @ptbn.iItem, rc)
                        MapWindowPoints(@ptbn.hdr.hwndFrom, %HWND_Desktop, rc, 2)
                        hTrackPopUpMenu = CreatePopUpMenu
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_PBFORMS, "PowerBASIC &Forms" + $Tab + "F7"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_PBCOMBR, "PowerBASIC &COM Browser"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_POWERLIB, "PowerBASIC &Library Manager"
                        If Len(pSed.CompilerResults) Then
                           AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_COMPILERRESULTS, "Compiler &Results"
                        Else
                           AppendMenu hTrackPopUpMenu, %MF_Grayed, %IDM_COMPILERRESULTS, "Compiler &Results"
                        End If
                        TrackPopupMenu(hTrackPopUpMenu, 0, rc.Left, rc.Bottom, 0, hwnd, ByVal %NULL)
                        DestroyMenu hTrackPopUpMenu
                     ' // Dropdown headers menu
                     Case %IDM_HEADERS
                        Toolbar_GetRect(@ptbn.hdr.hwndFrom, @ptbn.iItem, rc)
                        MapWindowPoints(@ptbn.hdr.hwndFrom, %HWND_Desktop, rc, 2)
                        hTrackPopUpMenu = CreatePopUpMenu
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_JRSINC1, "Jos Roca Headers I"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_JRSINC2, "Jos Roca Headers II"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_PBINC1, "PowerBASIC Headers I"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_PBINC2, "PowerBASIC Headers II"
                        CheckMenuItem hTrackPopUpMenu, %IDM_JRSINC1, IIf&(pSed.SelectedHeaders = 1, %MF_Checked, %MF_UnChecked)
                        CheckMenuItem hTrackPopUpMenu, %IDM_JRSINC2, IIf&(pSed.SelectedHeaders = 2, %MF_Checked, %MF_UnChecked)
                        CheckMenuItem hTrackPopUpMenu, %IDM_PBINC1, IIf&(pSed.SelectedHeaders = 3, %MF_Checked, %MF_UnChecked)
                        CheckMenuItem hTrackPopUpMenu, %IDM_PBINC2, IIf&(pSed.SelectedHeaders = 4, %MF_Checked, %MF_UnChecked)
                        TrackPopupMenu(hTrackPopUpMenu, 0, rc.Left, rc.Bottom, 0, hwnd, ByVal %NULL)
                        DestroyMenu hTrackPopUpMenu
                     ' // Dropdown tools menu
                     Case %IDM_TOOLS
                        Toolbar_GetRect(@ptbn.hdr.hwndFrom, @ptbn.iItem, rc)
                        MapWindowPoints(@ptbn.hdr.hwndFrom, %HWND_Desktop, rc, 2)
                        hTrackPopUpMenu = CreatePopUpMenu
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_TOOLS, "&Tools Manager" + $Tab + "F11"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_CALCULATOR, "&Calculator" + $Tab + "Ctrl+Shift+U"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_CHARMAP, "Character &Map" + $Tab + "Ctrl+Shift+K"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_NOTEPAD, "&Notepad" + $Tab + "Ctrl+Shift+N"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_MSPAINT, "&Paint" + $Tab + "Ctrl+Shift+P"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_RUNFILEDLG, "&Run File Dialog..." & $Tab & "Ctrl+Shift+R"
                        TrackPopupMenu(hTrackPopUpMenu, 0, rc.Left, rc.Bottom, 0, hwnd, ByVal %NULL)
                        DestroyMenu hTrackPopUpMenu
                     ' // Dropdown help menu
                     Case %IDM_HELP
                        Toolbar_GetRect(@ptbn.hdr.hwndFrom, @ptbn.iItem, rc)
                        MapWindowPoints(@ptbn.hdr.hwndFrom, %HWND_Desktop, rc, 2)
                        hTrackPopUpMenu = CreatePopUpMenu
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_HELP, "&Help Context" + $Tab + "F1"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_HELPCONTENTS, "Help Contents" + $Tab + "Ctrl+Alt+F1"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_HELPINDEX, "Help Index" + $Tab + "Ctrl+Alt+F2"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_HELPSEARCH, "Help Search" + $Tab + "Ctrl+Alt+F3"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, 0, ""
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, 0, ""
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_PBWINHELP, "PBWin Help"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_PBCCHELP, "PBCC Help"
                        AppendMenu hTrackPopUpMenu, %MF_Enabled, %IDM_RCHELP, "Resource Compiler Help"
                        TrackPopupMenu(hTrackPopUpMenu, 0, rc.Left, rc.Bottom, 0, hwnd, ByVal %NULL)
                        DestroyMenu hTrackPopUpMenu
                  End Select
               End If
         End Select
         Select Case @pnmhdr.code
            ' // Toolbar tooltips
            Case %TTN_GETDISPINFO
               pttdi = lParam
               @pttdi.hinst = GetModuleHandle(ByVal %NULL)
               Select Case @pttdi.hdr.hwndFrom
                  Case ToolBar_GetTooltips(pSed.hToolbar), ToolBar_GetTooltips(pSed.hBottomToolbar)
                     CSED_ToolbarTooltips(pttdi)
                     Exit Function
                  Case TabCtrl_GetTooltips(pSed.hTabMdi)
'                     vPath = pSed.TabFilePaths.Item(@pttdi.hdr.idFrom + 1)
                     pTabFilePaths = pSed.TabFilePaths
                     vPath = pTabFilePaths.Item(@pttdi.hdr.idFrom + 1)
                     szTooltipText = Variant$$(vPath)
                     @pttdi.lpszText = VarPtr(szTooltipText)
                     Exit Function
               End Select
            ' // Tab control selection changed
            Case %TCN_SelChange
               If @pnmhdr.idFrom = %IDC_TABMDI Then
                  ' // Identify the selected tab
                  nTab = TabCtrl_GetCurSel(pSed.hTabMdi)
                  ' // Activate the associated edit control
                  If pSed.TabFilePaths.Count => nTab + 1 Then
'                     vPath = pSed.TabFilePaths.Item(nTab + 1)
                     pTabFilePaths = pSed.TabFilePaths
                     vPath = pTabFilePaths.Item(nTab + 1)
                     CSED_TabMdiActivateWindow(Variant$$(vPath))
                  End If
               End If
         End Select

         ' // Pass unprocessed messages to the active MDI child and then to DefFrameProc()
         hwndActive = MdiGetActive(hwndClient)
         If IsWindow(hwndActive) Then SendMessage hwndActive, %WM_Notify, wParam, lParam

      Case %WM_GETMINMAXINFO
         ' // Set the pointer to the address of the MINMAXINFO structure
         Local ptmmi As MINMAXINFO Ptr
         ptmmi = lParam
         ' // Set the minimum and maximum sizes that can be
         ' // produced by dragging the borders of the window
         pWindow = CWindow_GetObjectFromWindowHandle(hwnd)
         If IsObject(pWindow) Then
            @ptmmi.ptMinTrackSize.x = 525 * pWindow.rxRatio
            @ptmmi.ptMinTrackSize.y = 125 * pWindow.ryRatio
            pWindow = Nothing
         Else
            @ptmmi.ptMinTrackSize.x = 525
            @ptmmi.ptMinTrackSize.y = 125
         End If
         Exit Function

      Case %WM_Size
         ' // If the window isn't minimized, resize it
         If wParam <> %SIZE_MINIMIZED Then
            ' // Resize the toolbar
            hToolBar = GetDlgItem(hwnd, %IDC_TOOLBAR)
            SendMessage hToolBar, uMsg, wParam, lParam
            ' // Calculate the size of the toolbar
            Local ToolBarHeight As Dword
            GetWindowRect hToolbar, rc
            ToolBarHeight = rc.Bottom - rc.Top
            ' // Calculate the size of the bottom toolbar
            hBottomToolBar = GetDlgItem(hwnd, %IDC_BOTTOMTOOLBAR)
            Local BottomToolBarHeight As Dword
            BottomToolBarHeight = ToolbarHeight
            ' // Resize the status bar
            hStatusBar = GetDlgItem(hwnd, %IDC_STATUSBAR)
            SendMessage hStatusbar, %WM_Size, wParam, lParam
'            InvalidateRect hStatusbar, BYVAL %NULL, %TRUE
            ' // Calculate the size of the status bar
            Local StatusBarHeight As Dword
            GetWindowRect hStatusBar, rc
            StatusBarHeight = rc.Bottom - rc.Top
            ' // Resize the tab control for MDI windows
            Local TabMdiHeight As Dword
            hTabMdi = GetDlgItem(hwnd, %IDC_TABMDI)
            GetWindowRect hTabMdi, rc
            TabMdiHeight = rc.Bottom - rc.Top
            GetClientRect hwnd, rc
            MoveWindow hTabMdi, rc.Left, rc.Top + ToolBarHeight, rc.Right + 2, TabMdiHeight, %TRUE
            MoveWindow hBottomToolBar, rc.Left, rc.Bottom - StatusBarHeight - BottomToolBarHeight, rc.Right + 2, BottomToolBarHeight, %TRUE
            ' // Resize the MDI client window
            If hwndClient Then
               ' // Retrieve the coordinates of the window's client area
               GetClientRect hwnd, rc
               MoveWindow hwndClient, rc.Left, rc.Top + ToolBarHeight + TabMdiHeight, rc.Right + 2, rc.Bottom - ToolBarHeight - TabMdiHeight - StatusBarHeight - BottomToolbarHeight, %TRUE
            End If
            ' // Redraw the Scintilla edit control
            If pSed.hEdit Then RedrawWindow pSed.hEdit, ByVal %NULL, %NULL, %RDW_ERASE Or %RDW_FRAME Or %RDW_INVALIDATE
         End If
         ' // Note: This message is not passed to DefFrameProc when space
         ' // is being reserved in the client area of the MDI frame
         ' // or controls on the MDI frame are resizeable.
         Exit Function

      Case %WM_Close
         If pSed.AskBeforeExit Then
            r = CSED_MsgBox(hwnd, "Are you sure you want to exit?", _
                  %MB_YesNo Or %MB_IconWarning, "Exit CSED")
            If r = %IdNo Then Exit Function
         End If
         ' // Save paths of loaded files
         pSed.SaveFileSet
         ' // Attempt to close all MDI child windows
         EnumChildWindows hwndClient, CodePtr(CSED_CloseEnumProc), 0
         ' // If child windows are still open abort closing the application
         If GetWindow(hwndClient, %GW_CHILD) Then Exit Function

      Case %WM_QUERYENDSESSION
         ' // Attempt to close all MDI child windows
         EnumChildWindows hwndClient, CodePtr(CSED_CloseEnumProc), 0
         ' // If child windows are still open abort closing the application
         If GetWindow(hwndClient, %GW_CHILD) Then Exit Function

      Case %WM_Destroy
         ' // Disable drag and drop files
         DragAcceptFiles hwnd, %FALSE
         ' // Save the window placement
         If pSed.WindowPlacement Then pSed.SaveWindowPlacement(hwnd)
         ' // Save last folder
         pSed.LastFolder = CurDir$
         ' // Close the main window
         PostQuitMessage 0
         Exit Function

   End Select

   If hwndClient Then
   ' // The DefFrameProc function provides default processing for any window
   ' // messages that the window procedure of a multiple-document interface (MDI)
   ' // frame window does not process. All window messages that are not explicitly
   ' // processed by the window procedure must be passed to the DefFrameProc
   ' // function, not the DefWindowProc function.
      Function = DefFrameProc(hwnd, hwndClient, uMsg, wParam, lParam)
   Else
   ' // The DefWindowProc function calls the default window procedure to provide
   ' // default processing for any window messages that an application does not process.
   ' // This function ensures that every message is processed. DefWindowProc
   ' // is called with the same parameters received by the window procedure.
      Function = DefWindowProc(hwnd, uMsg, wParam, lParam)
   End If

End Function
' ========================================================================================

' ========================================================================================
' Default CWindow MDI callback function.
' ========================================================================================
Function CSED_MDIWindowProc (ByVal hwnd As Dword, ByVal uMsg As Dword, ByVal wParam As Dword, ByVal lParam As Long) As Long

   Local hEdit      As Dword             ' // Handle of the edit control
   Local fTime      As Dword             ' // File time
   Local fSavedTime As Dword             ' // Saved file time
   Local nTab       As Long              ' // Tab index
   Local pWindow    As IWindow           ' // Reference to the IWindow interface
   Local rc         As RECT              ' // Client coordinates
   Local strPath    As String            ' // File path
   Local pt         As Point             ' // POINT structure
   Local cp         As Long              ' // Cursor position
   Local selStart   As Long              ' // Selection start
   Local selEnd     As Long              ' // Selection end
   Local hPopupMenu As Dword             ' // Popup menu handle
   Local x          As Long              ' // Word starting position
   Local y          As Long              ' // Word ending position
   Local buffer     As String            ' // General purpose buffer
   Local tProc      As CSED_PROCSTRUCT   ' // PROC structure

   Select Case uMsg

      Case %WM_Create
         ' // Retrieve a reference to the CWindow class from the MDI child window handle
         pWindow = CWindow_GetObjectFromWindowHandle(hwnd)
         ' // Create and edit control control
         If IsObject(pWindow) Then
            GetClientRect hwnd, rc
            hEdit = pWindow.AddControl("Scintilla", hwnd, %IDC_EDIT, "", 0, 0, 0, 0, _
                    %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll Or %WS_HScroll Or _
                    %ES_AutoHScroll Or %ES_AutoVScroll Or %ES_NoHideSel, 0)
            pWindow = Nothing
            Exit Function
         End If

      Case %WM_MDIACTIVATE
         If lParam = hWnd Then
            ' // Show the procedure name in the statusbar
            CSED_ResetCodefinder(pSed.hCodeFinderCB)
            If pSed.ShowProcedureName Then
               CSED_WithinProc(tProc)
               StatusBar_SetText(pSed.hStatusbar, 4, tProc.ProcName)
            End If
            Exit Function
         End If

      Case %WM_SetFocus
         ' // Post a message to restore the focus later
         ' // (some actions can steal the focus if we set it now)
         PostMessage hwnd, %WM_User + 999, pSed.hEdit, 0
         Exit Function

      Case %WM_User + 999
         ' // Get the path from the window caption
         strPath = AfxGetWindowText(hwnd)
         If Left$(UCase$(strPath), 8) <> "UNTITLED" Then
            ' // Get the time the file was last written
            fTime = CSED_GetFileTime(strPath)
            ' // Get the stored time
            fSavedTime = GetProp(hwnd, "FTIME")
            ' // If they are different ask for reloading else store the new time
            If fSavedTime <> fTime Then
               If CSED_MsgBox(hwnd, strPath & $CrLf & _
                  "File was changed by another application. Reload it?  ", _
                  %MB_YesNo Or %MB_IconQuestion, "File modified externally") = %IdYes Then
                  CSED_OpenFile strPath
               Else
                  SetProp hwnd, "FTIME", fTime
               End If
            End If
         End If
         ' // Set the focus
         If wParam Then SetFocus wParam
         ' // Show line and column
         CSED_ShowLinCol
         ' // Activate the associated tab
         nTab = CSED_GetTabNumberFromPath(strPath)
         If nTab > -1 Then TabCtrl_SetCursel(pSed.hTabMdi, nTab)
         Exit Function

      Case %WM_Command
         Select Case Lo(Word, wParam)
            Case %IDM_UNDO           : SendMessage pSed.hwndMain, %WM_Command, %IDM_UNDO, 0
            Case %IDM_REDO           : SendMessage pSed.hwndMain, %WM_Command, %IDM_REDO, 0
            Case %IDM_CLEAR          : SendMessage pSed.hwndMain, %WM_Command, %IDM_CLEAR, 0
            Case %IDM_CLEARALL       : SendMessage pSed.hwndMain, %WM_Command, %IDM_CLEARALL, 0
            Case %IDM_CUT            : SendMessage pSed.hwndMain, %WM_Command, %IDM_CUT, 0
            Case %IDM_COPY           : SendMessage pSed.hwndMain, %WM_Command, %IDM_COPY, 0
            Case %IDM_PASTE          : SendMessage pSed.hwndMain, %WM_Command, %IDM_PASTE, 0
            Case %IDM_SELECTALL      : SendMessage pSed.hwndMain, %WM_Command, %IDM_SELECTALL, 0
            Case %IDM_LINEDELETE     : SendMessage pSed.hwndMain, %WM_Command, %IDM_LINEDELETE, 0
            Case %IDM_BLOCKINDENT    : SendMessage pSed.hwndMain, %WM_Command, %IDM_BLOCKINDENT, 0
            Case %IDM_BLOCKUNINDENT  : SendMessage pSed.hwndMain, %WM_Command, %IDM_BLOCKUNINDENT, 0
            Case %IDM_COMMENT        : SendMessage pSed.hwndMain, %WM_Command, %IDM_COMMENT, 0
            Case %IDM_UNCOMMENT      : SendMessage pSed.hwndMain, %WM_Command, %IDM_UNCOMMENT, 0
            Case %IDM_FORMATREGION   : SendMessage pSed.hwndMain, %WM_Command, %IDM_FORMATREGION, 0
            Case %IDM_TABULATEREGION : SendMessage pSed.hwndMain, %WM_Command, %IDM_TABULATEREGION, 0
            Case %IDM_SELTOUPPERCASE : SendMessage pSed.hwndMain, %WM_Command, %IDM_SELTOUPPERCASE, 0
            Case %IDM_SELTOLOWERCASE : SendMessage pSed.hwndMain, %WM_Command, %IDM_SELTOLOWERCASE, 0
            Case %IDM_SELTOMIXEDCASE : SendMessage pSed.hwndMain, %WM_Command, %IDM_SELTOMIXEDCASE, 0
            Case %IDM_TOGGLEBOOKMARK : SendMessage pSed.hwndMain, %WM_Command, %IDM_TOGGLEBOOKMARK, 0
            Case %IDM_INSERTGUID     : SendMessage pSed.hwndMain, %WM_Command, %IDM_INSERTGUID, 0
            Case %IDM_HELP           : SendMessage pSed.hwndMain, %WM_Command, %IDM_HELP, 0

            Case %IDM_GOTOSELFILE
               ' // Retrieve the name of the file under the caret
               ' // Needed to get Alt+F7 to work
               ' // Note: Does not work if the path contains spaces.
               buffer = SCI_GetWord(pSed.hEdit)
               CSED_LoadSelectedFile(hwnd, buffer)
         End Select
         Exit Function

      Case %WM_CONTEXTMENU
         ' // Change the focus and the caret position if there is not selected text
         SetFocus wParam
         pt.x = Lo(Word, lParam)
         pt.y = Hi(Word, lParam)
         ScreenToClient wParam, pt
         cp = SCI_PositionFromPoint(wParam, pt.x, pt.y)
         selStart = SCI_GetSelectionStart(wParam)
         selEnd = SCI_GetSelectionEnd(wParam)
         If selStart = selEnd Then SCI_SetSel(wParam, cp, cp)
         ' // Retrieve the word under the cursor
         buffer = SCI_GetWord(pSed.hEdit)
         ' // Build the menu
         hPopupMenu = CSED_CreateContextMenu(buffer)
         GetCursorPos pt
         TrackPopupMenu hPopupMenu, 0, pt.x, pt.y, 0, hwnd, ByVal %NULL
         DestroyMenu hPopupMenu
         UpdateWindow pSed.hEdit

      Case %WM_Notify
         ' // Process Scintilla control notification messages
         Select Case Lo(Word, wParam)
         Case %IDC_EDIT
            Sci_OnNotify hwnd, wParam, lParam
            Exit Function
         End Select

      Case %WM_Size
         If wParam <> %SIZE_MINIMIZED Then
            ' // Resize the window and/or its controls
            hEdit = GetDlgItem(hwnd, %IDC_EDIT)
            MoveWindow hEdit, 0, 0, Lo(Word, lParam), Hi(Word, lParam), %FALSE
         End If

         ' Don't exit. Let DefMDIChildProc to process the message for
         ' properly resizing of the MDI child window.

      Case %WM_Destroy
         ' // Do cleanunp if needed, such removing properties attached
         ' // to the MDI child window.
         ' Remove the FTIME property
         RemoveProp(hwnd, "FTIME")
         ' // Remove the associated tab
         CSED_TabMdiRemoveTab(AfxGetWindowText(hwnd))
         ' // Clear the code finder combo box
         CSED_ResetCodefinder(pSed.hCodeFinderCB)
         Exit Function

   End Select

   ' // The DefMDIChildProc function provides default processing for any window
   ' // message that the window procedure of a multiple-document interface (MDI)
   ' // child window does not process. A window message not processed by the window
   ' // procedure must be passed to the DefMDIChildProc function, not to the
   ' // DefWindowProc function.
   Function = DefMDIChildProc(hwnd, uMsg, wParam, lParam)

End Function
' ========================================================================================

' ========================================================================================
' Creates a new MDI child window
' ========================================================================================
Function CSED_CreateMdiChild (ByVal strPath As String) As Dword

   Local hMdi As Dword
   Local nTab As Long
   Local bstrPath As WString

   ' // Disable redrawing
   AfxDisableWindowRedraw pSed.hwndClient

   hMdi = CreateMdiChild("PBFrameClass", pSed.hwndClient, ByCopy strPath, IIf&(pSed.MaximizeEditWindows = %BST_CHECKED, %WS_Maximize, 0))
   If hMdi Then
      ' // Set the icon
      AfxSetWindowSmallIcon(hMdi, LoadIcon(GetModuleHandle(ByVal %NULL), ByVal 101))
      ' // Add new tab
      ' // --------------------------------------------
      ' // Workaround: The Add method of the linked list
      ' // collection needs an Unicode string
      bStrPath = strPath
      pSed.TabFilePaths.Add(bstrPath)
      ' // --------------------------------------------
      nTab = TabCtrl_AddTab(pSed.hTabMdi, 0, PathName$(Namex, strPath))
      ' // Set it as the current selection on the tab control
      TabCtrl_SetCurSel(pSed.hTabMdi, nTab)
      ' // Note: In some OSes, such XP SP3 and Windows 7, files that begin with a number,
      ' // such 0.BAS are displayed in the tab wrongly, e.g. as BAS.0.
      ' // Apparently, it's a bug of the tab control.
      ' // As a workaround, call TabCtrl_SetText after adding and selecting the tab.
      TabCtrl_SetText(pSed.hTabMdi, nTab, PathName$(Namex, strPath))
      ' // Set the Scintilla options
      CSED_SetScintillaOptions(pSed.hEdit, PathName$(Extn, strPath))
      'sendmessage pSed.hEdit, %SCI_SETCARETSTICKY, 0, 0
      sendmessage pSed.hEdit, %SCI_TOGGLECARETSTICKY, 0, 0
      'sendmessage pSed.hEdit, %SCI_TOGGLECARETSTICKY, 0, 0
      'aaaaaaaa  aaaaaa
      'bbbbbbbbbbbb

   End If
   Function = hMdi

   ' // Enable redrawing
   AfxEnableWindowRedraw pSed.hwndClient
   ' // Redraw the window
'   RedrawWindow pSed.hwndClient, BYVAL %NULL, %NULL, %RDW_ERASE OR %RDW_FRAME OR %RDW_INVALIDATE OR %RDW_ALLCHILDREN
   ' // Redraw the Scintilla edit control
   If pSed.hEdit Then RedrawWindow pSed.hEdit, ByVal %NULL, %NULL, %RDW_ERASE Or %RDW_FRAME Or %RDW_INVALIDATE

End Function
' ========================================================================================

' ========================================================================================
' Destroys all MDI child windows.
' ========================================================================================
Function CSED_CloseEnumProc ( _
                      ByVal hwnd As Dword, _                   ' // Handle of enumerated child window
                      ByVal lParam As Long _                   ' // Unused
                      ) As Long


local test as long
  sdfg

  asdf
     asdf

   asdf
                                             {    }
   ' // Skip icon title windows        {  }
   If IsTrue GetWindow(hwnd, %GW_OWNER) Then
      Function = %TRUE
      Exit Function
   End If

'   SendMessage GetParent(hwnd), %WM_MDIRESTORE, hwnd, 0
   If IsFalse SendMessage(hwnd, %WM_QUERYENDSESSION, 0, 0) Then
      Function = %TRUE
      Exit Function
   End If

   ' // Get the path of the file from the window caption
   Local r As Long
   Local strPath As String
   strPath = AfxGetWindowText(hwnd)

   ' // See if the document has been modified
   If SCI_GetModify(pSed.hEdit) Then
      Beep
      r = CSED_MsgBox(hwnd, "Save current changes? " & PathName$(Namex, strPath), _
            %MB_YesNoCancel Or %MB_IconQuestion)
      If r = %IdCancel Then
         Function = %FALSE
         Exit Function
      Else
         If r = %IdYes Then CSED_SaveFile hwnd, pSed.hEdit, %FALSE _ asdf


      End If
   End If

   ' // Destroy the MDI child window
   MdiDestroy GetParent(hwnd), hwnd

   Function = %TRUE

End Function
' =======================================================================================

prefix " ! "
            asdf

end prefix

union test

end union

class xyz
class method     end method
override method asdf

         interface seasdf
         try

override property asdf     end method _asdf


         end  interface
        try

end class


enum asd

   macro asd =


   for i=1  :  next



   do                  loop     _asdf
      try
      while asdf   wend

 '        wend

         loop

   next i

asdf
   end macro
                     Function = %TRUE  789


fastproc


 prefix


 prefix "asm  "  as   ;asdf
    aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa
l1:
   bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb
  end prefix


  asdf

  asdf                                    '

'****************************************************************************************
                    rem    R   EM rem
                                      '
        !
         asm



         default (identifiers)                schwarz       -> ok
         asm                                  rot           -> ok liste + farbe anlegen
         operator                             rot   bold    -> ok
         preprocessor '#utility               orange        -> ok    farbe anlegen
         keyword                              blau          -> ok
         keyword2     #metastatements         rot (bold ? ) -> ok  liste + farbe anlegen

         constants (%.. + $.. )?              cyan          ->  liste + farbe anlegen
         string                               magenta       -> ok
         comment                              grn          -> ok (rem, ', ; (asm comment) und "_" alles ok)
         numbers ?                            braun bold    -> ok


                   asm


#Utility   asdf  "asdf'

        #compile "asdf

          !asm    ;asdf



End Function
' =======================================================================================






    